//ļTapTradeAPI ʹõͺݽṹ
#ifndef TAP_TRADE_API_DATA_TYPE_H
#define TAP_TRADE_API_DATA_TYPE_H
#include "TapAPICommDef.h"

#pragma pack(push, 1)


//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIACCOUNTTYPE	˺
 *	@{
 */
//=============================================================================
//! ˺
typedef TAPICHAR			TAPIAccountType;
//! ˿ͻ
const TAPIAccountType		TAPI_ACCOUNT_TYPE_PERSON				= 'P';
//! ͻ
const TAPIAccountType		TAPI_ACCOUNT_TYPE_ORGANIZATION		    = 'O';
/** @}*/

//=============================================================================
/**
*	\addtogroup G_DATATYPE_T_TAPIRIGHTIDTYPE	Ȩޱ
*	@{
*/
//=============================================================================
//! Ȩޱ
typedef TAPIINT32			TAPIRightIDType;
//! ϵͳɾ
const TAPIRightIDType		TAPI_RIGHT_ORDER_DEL	= 30001;
//! 
const TAPIRightIDType		TAPI_RIGHT_ORDER_CHECK	= 30002;
//! ֻɲѯ
const TAPIRightIDType		TAPI_RIGHT_ONLY_QRY		= 31000;
//! ֻɿ
const TAPIRightIDType		TAPI_RIGHT_ONLY_OPEN	= 31001;
//! ڲҵ
const TAPIRightIDType		TAPI_RIGHT_SHFE_QUOTE	= 31002;
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIUSERTYPETYPE	¼û
 *	@{
 */
//=============================================================================
//! ¼û
typedef TAPIINT32			TAPIUserTypeType;
//! Ͷû
const TAPIUserTypeType		TAPI_USERTYPE_CLIENT					=10000;
//! 
const TAPIUserTypeType		TAPI_USERTYPE_BROKER					=20000;
//! Ա
const TAPIUserTypeType		TAPI_USERTYPE_TRADER					=30000;
//! 
const TAPIUserTypeType		TAPI_USERTYPE_RISK						=40000;
//! Ա
const TAPIUserTypeType		TAPI_USERTYPE_MANAGER					=50000;
//! 
const TAPIUserTypeType		TAPI_USERTYPE_QUOTE						=60000;
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIACCOUNTSTATE	˺״̬
 *	@{
 */
//=============================================================================
//! ˺״̬
typedef TAPICHAR			TAPIAccountState;
//! 
const TAPIAccountState		TAPI_ACCOUNT_STATE_NORMAL				= 'N';
//! 
const TAPIAccountState		TAPI_ACCOUNT_STATE_CANCEL				= 'C';
//! 
const TAPIAccountState		TAPI_ACCOUNT_STATE_SLEEP               = 'S';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIACCOUNTFAMILYTYPE	˻
 *	@{
 */
//=============================================================================
//! ˻
typedef TAPICHAR			TAPIAccountFamilyType;
//! ˺
const	TAPIAccountFamilyType	TAPI_ACCOUNT_FAMILYTYPE_NOMAL	='N';
//! ˻
const	TAPIAccountFamilyType	TAPI_ACCOUNT_FAMILYTYPE_CHILD	='C';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIORDERTYPETYPE	ί
 *	@{
 */
//=============================================================================
//! ί
typedef TAPICHAR				TAPIOrderTypeType;
//! м
const TAPIOrderTypeType			TAPI_ORDER_TYPE_MARKET				= '1';
//! ޼
const TAPIOrderTypeType			TAPI_ORDER_TYPE_LIMIT				= '2';
//! мֹ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_STOP_MARKET			= '3';
//! ޼ֹ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_STOP_LIMIT			= '4';
//! ȨȨ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPT_EXEC			= '5';
//! ȨȨ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPT_ABANDON			= '6';
//! ѯ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_REQQUOT				= '7';
//! Ӧ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_RSPQUOT				= '8';
//! 
const TAPIOrderTypeType			TAPI_ORDER_TYPE_SWAP				= '9';
//! 
const TAPIOrderTypeType			TAPI_ORDER_TYPE_COMB                = 'A';
//! 
const TAPIOrderTypeType			TAPI_ORDER_TYPE_UNCOMB              = 'B';
//! мֹӯ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_PROFIT_MARKET       = 'C';
//! ޼ֹӯ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_PROFIT_LIMIT        = 'D';
//! ױ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_HEDGE               = 'E';
//! ȨԶԳ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPTION_AUTO_CLOSE   = 'F';
//! ԼڻԶԳ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_FUTURE_AUTO_CLOSE   = 'G';
//! 
const TAPIOrderTypeType			TAPI_ORDER_TYPE_MARKET_POSITION_KEEP = 'H';
//! ȡԶȨ
const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPTION_AUTOEXEC_ABAND = 'I';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIORDERSOURCETYPE	ίԴ
 *	@{
 */
//=============================================================================
//! ίԴ
typedef TAPICHAR				TAPIOrderSourceType;
//! ӵ
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_SELF_ETRADER			= '1';
//! ӵ
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_PROXY_ETRADER			= '2';
//! ⲿӵ(ⲿϵͳµϵͳ¼)
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_JTRADER				= '3';
//! ˹¼뵥(ⲿʽµϵͳ¼)
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_MANUAL				= '4';
//! carry
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_CARRY					= '5';
//! ʽ
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_PROGRAM				= '6';
//! Ȩ
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_DELIVERY				= '7';
//! Ȩ
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_ABANDON				= '8';
//! ͨ
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_CHANNEL				= '9';
//! ʢAPI
const TAPIOrderSourceType		TAPI_ORDER_SOURCE_ESUNNY_API			= 'A';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPITIMEINFORCETYPE	ίЧ
 *	@{
 */
//=============================================================================
//! ίЧ
typedef TAPICHAR				TAPITimeInForceType;
//! Ч
const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_GFD					= '0';
//! ȡǰЧ
const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_GTC					= '1';
//! ָǰЧ
const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_GTD					= '2';
//! FAKIOC
const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_FAK					= '3';
//! FOK
const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_FOK					= '4';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPISIDETYPE	
 *	@{
 */
//=============================================================================
//! 
typedef TAPICHAR				TAPISideType;
//! 
const TAPISideType				TAPI_SIDE_NONE							= 'N';
//! 
const TAPISideType				TAPI_SIDE_BUY							= 'B';
//! 
const TAPISideType				TAPI_SIDE_SELL							= 'S';
//! ˫
const TAPISideType				TAPI_SIDE_ALL    						= 'A';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIPOSITIONEFFECTTYPE	ƽ
 *	@{
 */
//=============================================================================
//! ƽ
typedef TAPICHAR				TAPIPositionEffectType;
//! ֿƽ
const TAPIPositionEffectType	TAPI_PositionEffect_NONE				= 'N';
//! 
const TAPIPositionEffectType	TAPI_PositionEffect_OPEN				= 'O';
//! ƽ
const TAPIPositionEffectType	TAPI_PositionEffect_COVER			= 'C';
//! ƽ
const TAPIPositionEffectType	TAPI_PositionEffect_COVER_TODAY		= 'T';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIHEDGEFLAGTYPE	Ͷֵ
 *	@{
 */
//=============================================================================
//! Ͷֵ
typedef TAPICHAR				TAPIHedgeFlagType;
//! 
const TAPIHedgeFlagType			TAPI_HEDGEFLAG_NONE					= 'N';
//! Ͷ
const TAPIHedgeFlagType			TAPI_HEDGEFLAG_T					= 'T';
//! ֵ
const TAPIHedgeFlagType			TAPI_HEDGEFLAG_B					= 'B';
//! 
const TAPIHedgeFlagType			TAPI_HEDGEFLAG_L					= 'L';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIORDERSTATETYPE	ί״̬
 *	@{
 */
//=============================================================================
//! ί״̬
typedef TAPICHAR				TAPIOrderStateType;
//! նύ
const TAPIOrderStateType		TAPI_ORDER_STATE_SUBMIT				= '0';
//! 
const TAPIOrderStateType		TAPI_ORDER_STATE_ACCEPT				= '1';
//! Դ
const TAPIOrderStateType		TAPI_ORDER_STATE_TRIGGERING			= '2';
//! 
const TAPIOrderStateType		TAPI_ORDER_STATE_EXCTRIGGERING		= '3';
//! Ŷ
const TAPIOrderStateType		TAPI_ORDER_STATE_QUEUED				= '4';
//! ֳɽ
const TAPIOrderStateType		TAPI_ORDER_STATE_PARTFINISHED		= '5';
//! ȫɽ
const TAPIOrderStateType		TAPI_ORDER_STATE_FINISHED			= '6';
//! (Ŷʱ״̬)
const TAPIOrderStateType		TAPI_ORDER_STATE_CANCELING			= '7';
//! ޸(Ŷʱ״̬)
const TAPIOrderStateType		TAPI_ORDER_STATE_MODIFYING			= '8';
//! ȫ
const TAPIOrderStateType		TAPI_ORDER_STATE_CANCELED			= '9';
//! ѳ൥
const TAPIOrderStateType		TAPI_ORDER_STATE_LEFTDELETED		= 'A';
//! ָʧ
const TAPIOrderStateType		TAPI_ORDER_STATE_FAIL				= 'B';
//! ɾ
const TAPIOrderStateType		TAPI_ORDER_STATE_DELETED			= 'C';
//! ѹ
const TAPIOrderStateType		TAPI_ORDER_STATE_SUPPENDED			= 'D';
//! ɾ
const TAPIOrderStateType		TAPI_ORDER_STATE_DELETEDFOREXPIRE	= 'E';
//! Чѯ۳ɹ
const TAPIOrderStateType		TAPI_ORDER_STATE_EFFECT				= 'F';
//! 롪ȨȨɹ
const TAPIOrderStateType		TAPI_ORDER_STATE_APPLY				= 'G';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPICALCULATEMODETYPE	㷽ʽ
 *	@{
 */
//=============================================================================
//! 㷽ʽ
typedef TAPICHAR               TAPICalculateModeType;
//! 
const TAPICalculateModeType		TAPI_CALCULATE_MODE_PERCENTAGE          = '1';
//! 
const TAPICalculateModeType		TAPI_CALCULATE_MODE_QUOTA               = '2';
//! Էʽ
const TAPICalculateModeType		TAPI_CALCULATE_MODE_ABSOLUTE		= '7';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIMATCHSOURCETYPE	ɽԴ
 *	@{
 */
//=============================================================================
//! ɽԴ
typedef TAPICHAR				TAPIMatchSourceType;
//! ȫ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_ALL                   = '0';
//! ӵ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_SELF_ETRADER          = '1';
//! ӵ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_PROXY_ETRADER         = '2';
//! ⲿӵ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_JTRADER				= '3';
//! ˹¼뵥
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_MANUAL				= '4';
//! carry
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_CARRY					= '5';
//! ʽ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_PROGRAM				= '6';
//! Ȩ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_DELIVERY				= '7';
//! Ȩ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_ABANDON				= '8';
//! ͨ
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_CHANNEL				= '9';
//! ʢAPI
const TAPIMatchSourceType		TAPI_MATCH_SOURCE_ESUNNY_API			= 'A';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIOPENCLOSEMODETYPE	ƽʽ
 *	@{
 */
//=============================================================================
//! ƽʽ
typedef TAPICHAR				TAPIOpenCloseModeType;
//! ֿƽ
const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_NONE				= 'N';
//! ƽδ˽
const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_UNFINISHED			= 'U';
//! ֺֿƽ
const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_OPENCOVER			= 'C';
//! ֿ֡ƽֺƽ
const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_CLOSETODAY			= 'T';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIFUTUREALGTYPE	ڻ㷨
 *	@{
 */
//=============================================================================
//! ڻ㷨
typedef TAPICHAR				TAPIFutureAlgType;
//! 
const TAPIFutureAlgType			TAPI_FUTURES_ALG_ZHUBI                  = '1';
//! 
const TAPIFutureAlgType			TAPI_FUTURES_ALG_DINGSHI                = '2';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIOPTIONALGTYPE	Ȩ㷨
 *	@{
 */
//=============================================================================
//! Ȩ㷨
typedef TAPICHAR				TAPIOptionAlgType;
//! ڻʽ
const TAPIOptionAlgType         TAPI_OPTION_ALG_FUTURES                 = '1';
//! Ȩʽ
const TAPIOptionAlgType         TAPI_OPTION_ALG_OPTION                  = '2';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIBANKACCOUNTLWFLAGTYPE	ұʶ
 *	@{
 */
//=============================================================================
//! ұʶ
typedef TAPICHAR				TAPIBankAccountLWFlagType;
//! ˻
const TAPIBankAccountLWFlagType	TAPI_LWFlag_L					= 'L';
//! ͻ˻
const TAPIBankAccountLWFlagType	TAPI_LWFlag_W					= 'W';
/** @}*/


//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIMARGINCALCULATEMODETYPE	ڻ֤ʽ
 *	@{
 */
//=============================================================================
//! ڻ֤ʽ
typedef TAPICHAR				TAPIMarginCalculateModeType;
//! ֱ
const TAPIMarginCalculateModeType TAPI_DEPOSITCALCULATE_MODE_FEN     = '1';
//! 
const TAPIMarginCalculateModeType TAPI_DEPOSITCALCULATE_MODE_SUO     = '2';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIOPTIONMARGINCALCULATEMODETYPE	Ȩ֤ʽ
 *	@{
 */
//=============================================================================
//! Ȩ֤ʽ,ݴжϸƷȨúü㹫ʽ㱣֤
typedef TAPICHAR				TAPIOptionMarginCalculateModeType;
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPICMBDIRECTTYPE	Ϸ
 *	@{
 */
//=============================================================================
//! Ϸ,ƷϺԼ͵ڼͬ
typedef TAPICHAR				TAPICmbDirectType;
//! ͵һһ
const TAPICmbDirectType         TAPI_CMB_DIRECT_FIRST                    = '1';
//! ͵ڶһ
const TAPICmbDirectType         TAPI_CMB_DIRECT_SECOND                   = '2';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIDELIVERYMODETYPE	Ȩʽ
 *	@{
 */
//=============================================================================
//! Ȩʽ,ڻȨ˽ķʽ
typedef TAPICHAR				TAPIDeliveryModeType;
//! ʵｻ
const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_GOODS			= 'G';
//! ֽ𽻸
const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_CASH				= 'C';
//! ȨȨ
const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_EXECUTE			= 'E';
//! Ȩ
const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_ABANDON			= 'A';
//! ۽Ȩ
const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_HKF				= 'H';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPICONTRACTTYPETYPE	Լ
 *	@{
 */
//=============================================================================
//! Լ
typedef TAPICHAR				TAPIContractTypeType;
//! Լ
const TAPIContractTypeType		TAPI_CONTRACT_TYPE_TRADEQUOTE		='1';
//! Լ
const TAPIContractTypeType		TAPI_CONTRACT_TYPE_QUOTE			='2';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPITACTICSTYPETYPE	Ե
 *	@{
 */
//=============================================================================
//! Ե
typedef TAPICHAR					TAPITacticsTypeType;
//! 
const TAPITacticsTypeType			TAPI_TACTICS_TYPE_NONE				= 'N';
//! Ԥ()
const TAPITacticsTypeType			TAPI_TACTICS_TYPE_READY				= 'M';
//! Զ
const TAPITacticsTypeType			TAPI_TACTICS_TYPE_ATUO				= 'A';
//! 
const TAPITacticsTypeType			TAPI_TACTICS_TYPE_CONDITION			= 'C';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIORDERACT	
 *	@{
 */
//=============================================================================
//! 
typedef TAPICHAR		TAPIORDERACT;
//! 
const TAPIORDERACT APIORDER_INSERT			= '1';
//! ĵ
const TAPIORDERACT APIORDER_MODIFY			= '2';
//! 
const TAPIORDERACT APIORDER_DELETE			= '3';
//! 
const TAPIORDERACT APIORDER_SUSPEND			= '4';
//! 
const TAPIORDERACT APIORDER_ACTIVATE		= '5';
//! ɾ
const TAPIORDERACT APIORDER_SYSTEM_DELETE	= '6';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPITRIGGERCONDITIONTYPE	
 *	@{
 */
//=============================================================================
//! 
typedef TAPICHAR				TAPITriggerConditionType;
//! 
const TAPITriggerConditionType	TAPI_TRIGGER_CONDITION_NONE			= 'N';
//! ڵ
const TAPITriggerConditionType	TAPI_TRIGGER_CONDITION_GREAT		= 'G';
//! Сڵ
const TAPITriggerConditionType	TAPI_TRIGGER_CONDITION_LITTLE		= 'L';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPITRIGGERPRICETYPETYPE	۸
 *	@{
 */
//=============================================================================
//! ۸
typedef TAPICHAR				TAPITriggerPriceTypeType;
//! 
const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_NONE				= 'N';
//! 
const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_BUY				= 'B';
//! 
const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_SELL				= 'S';
//! ¼
const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_LAST				= 'L';
/** @}*/

//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIMARKETLEVELTYPE	м۴
 *	@{
 */
//=============================================================================
//! м۴
typedef TAPIUINT8				TAPIMarketLevelType;
//! 
const TAPIMarketLevelType	TAPI_MARKET_LEVEL_0						= 0;
//! 1ż
const TAPIMarketLevelType	TAPI_MARKET_LEVEL_1						= 1;
//! 5
const TAPIMarketLevelType	TAPI_MARKET_LEVEL_5						= 5;
//! 10
const TAPIMarketLevelType	TAPI_MARKET_LEVEL_10					= 10;
/** @}*/


//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPITRADINGSTATETYPE	״̬
 *	@{
 */
//=============================================================================
//! ״̬
typedef TAPICHAR               TAPITradingStateType;
//! Ͼ
const TAPITradingStateType      TAPI_TRADE_STATE_BID                = '1';
//! Ͼ۴
const TAPITradingStateType      TAPI_TRADE_STATE_MATCH              = '2';
//! 
const TAPITradingStateType      TAPI_TRADE_STATE_CONTINUOUS         = '3';
//! ͣ
const TAPITradingStateType      TAPI_TRADE_STATE_PAUSED             = '4';
//! 
const TAPITradingStateType      TAPI_TRADE_STATE_CLOSE              = '5';
//! дʱ
const TAPITradingStateType      TAPI_TRADE_STATE_DEALLAST           = '6';
//! δ
const TAPITradingStateType		TAPI_TRADE_STATE_GWDISCONNECT		= '0';
//! δ֪״̬
const TAPITradingStateType		TAPI_TRADE_STATE_UNKNOWN			= 'N';
//! ʼ
const TAPITradingStateType		TAPI_TRADE_STATE_INITIALIZE			= 'I';
//! ׼
const TAPITradingStateType		TAPI_TRADE_STATE_READY				= 'R';
/** @}*/



//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPINOTICEIGNOREFLAGTYPE	Ժ̨֪ͨ
 *	@{
 */
//=============================================================================
//! Ժ̨֪ͨ
typedef TAPIUINT32              TAPINoticeIgnoreFlagType;
//! Ϣ
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_NONE				= 0x00000000;
//! 
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_ALL				= 0xFFFFFFFF;
//! ʽ:OnRtnFund
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_FUND				= 0x00000001;
//! ί:OnRtnOrder
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_ORDER				= 0x00000002;
//! Գɽ:OnRtnFill
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_FILL				= 0x00000004;
//! Գֲ:OnRtnPosition
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_POSITION			= 0x00000008;
//! ƽ:OnRtnClose
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_CLOSE				= 0x00000010;
//! Գֲӯ:OnRtnPositionProfit
const TAPINoticeIgnoreFlagType TAPI_NOTICE_IGNORE_POSITIONPROFIT	= 0x00000020;
/** @}*/


//=============================================================================
/**
 *	\addtogroup G_DATATYPE_T_TAPIORDERQRYTYPETYPE	ίвѯ
 *	@{
 */
//=============================================================================
//! ίвѯ
typedef TAPICHAR              TAPIOrderQryTypeType;
//! ί
const TAPIOrderQryTypeType TAPI_ORDER_QRY_TYPE_ALL				= 'A';
//! ֻδί
const TAPIOrderQryTypeType TAPI_ORDER_QRY_TYPE_UNENDED			= 'U';
/** @}*/


//! ------------------------------------------------------------------------------------------

//! ¼֤Ϣ
struct TapAPITradeLoginAuth
{
	TAPISTR_20					UserNo;					///< û
	TAPISTR_50					AuthCode;				///< Ȩ
	TAPISTR_30					AppID;					///< 汾
	TAPIYNFLAG					ISModifyPassword;		///< Ƿ޸	
	TAPISTR_20					Password;				///< 
	TAPISTR_20					NewPassword;			///< 
	TAPIYNFLAG					ISDDA;					///< ǷҪ̬֤
	TAPISTR_30					DDASerialNo;			///< ̬֤
	TAPINoticeIgnoreFlagType	NoticeIgnoreFlag;		///< ֪ͨ
};

//! ¼Ϣ
struct TapAPITradeLoginRspInfo
{
	TAPISTR_20					UserNo;							///< û
	TAPIUserTypeType			UserType;						///< û
	TAPISTR_20					UserName;						///< û
	TAPISTR_20					QuoteTempPassword;				///< ʱ
	TAPISTR_50					ReservedInfo;					///< ԤϢ
	TAPISTR_40					LastLoginIP;					///< ϴε¼IP
	TAPIUINT32					LastLoginPort;					///< ϴε¼˿
	TAPISTR_500                 LastLoginInfo;                  ///< ϴε¼Ϣ
	TAPIDATETIME				LastLoginTime;					///< ϴε¼ʱ
	TAPIDATETIME				LastLogoutTime;					///< ϴ˳ʱ
	TAPIDATE					TradeDate;						///< ǰ
	TAPIDATETIME				LastSettleTime;					///< ϴνʱ
	TAPIDATETIME				StartTime;						///< ϵͳʱ
	TAPIDATETIME				InitTime;						///< ϵͳʼʱ
	TAPIAuthTypeType			AuthType;						///< ûȨ
	TAPIDATETIME				AuthDate;						///< ûȨ
};

//! ¼ɼϢ
struct TapAPISubmitUserLoginInfo
{
	TAPISTR_20					UserNo;								///< ¼û
	TAPISTR_500					GatherInfo;							///< ûնϢ
	TAPISTR_40					ClientLoginIP;						///< ûIP
	TAPIUINT32					ClientLoginPort;					///< ûPort
	TAPIDATETIME				ClientLoginDateTime;				///< û¼ʱ
	TAPISTR_30					ClientAppID;						///< ûAppID
	TAPIUINT32					AuthKeyVersion;						///< ûնϢԿ汾
};

//! ¼ɼϢӦ
struct TapAPISubmitUserLoginRspInfo
{
	TAPISTR_20					UserNo;								///< ¼û
	TAPIUINT32					ErrorCode;				    		///< 
	TAPISTR_50                  ErrorText;                          ///< Ϣ
};

//! ˺Ϣѯ
struct TapAPIAccQryReq
{
	TAPISTR_20					AccountNo;						///< ʽ˺				
};

//! ʽ˺Ϣ
struct TapAPIAccountInfo
{
	TAPISTR_20              AccountNo;                              ///< ʽ˺
	TAPIAccountType			AccountType;                            ///< ˺
	TAPIAccountState		AccountState;                           ///< ˺״̬
	TAPISTR_20				AccountShortName;                       ///< ˺ż
	TAPIYNFLAG				AccountIsDocHolder;                     ///< Ƿ֤
	TAPIYNFLAG				IsMarketMaker;							///< Ƿ
	TAPIAccountFamilyType	AccountFamilyType;						///< ˺
};

//! ͻµṹ
struct TapAPINewOrder
{
	TAPISTR_20					AccountNo;						///< ͻʽʺ
	TAPISTR_10					ExchangeNo;						///< 
	TAPICommodityType			CommodityType;					///< Ʒ
	TAPISTR_10					CommodityNo;					///< Ʒֱ
	TAPISTR_10					ContractNo;						///< Լ1
	TAPISTR_10					StrikePrice;					///< ִм۸1
	TAPICallOrPutFlagType		CallOrPutFlag;					///< ſ1
	TAPISTR_10					ContractNo2;					///< Լ2
	TAPISTR_10					StrikePrice2;					///< ִм۸2
	TAPICallOrPutFlagType		CallOrPutFlag2;					///< ſ2
	TAPIOrderTypeType			OrderType;						///< ί
	TAPIOrderSourceType			OrderSource;					///< ίԴ
	TAPITimeInForceType			TimeInForce;					///< ίЧ
	TAPIDATETIME				ExpireTime;						///< Ч(GTDʹ)
	TAPIYNFLAG					IsRiskOrder;					///< Ƿձ
	TAPISideType				OrderSide;						///< 
	TAPIPositionEffectType		PositionEffect;					///< ƽ־1
	TAPIPositionEffectType		PositionEffect2;				///< ƽ־2
	TAPISTR_50					InquiryNo;						///< ѯۺ
	TAPIHedgeFlagType			HedgeFlag;						///< Ͷֵ
	TAPIREAL64					OrderPrice;						///< ίм۸1
	TAPIREAL64					OrderPrice2;					///< ίм۸2Ӧʹ
	TAPIREAL64					StopPrice;						///< ۸
	TAPIUINT32					OrderQty;						///< ί
	TAPIUINT32					OrderMinQty;					///< Сɽ
	TAPIUINT32					MinClipSize;					///< ɽС
	TAPIUINT32					MaxClipSize;					///< ɽ
	TAPIINT32					RefInt;							///< Ͳοֵ
	TAPISTR_50					RefString;						///< ַοֵ
	TAPITacticsTypeType			TacticsType;					///< Ե
	TAPITriggerConditionType	TriggerCondition;				///< 
	TAPITriggerPriceTypeType	TriggerPriceType;				///< ۸	
	TAPIYNFLAG					AddOneIsValid;					///< ǷT+1Ч
	TAPIUINT32					OrderQty2;						///< ί2
	TAPIHedgeFlagType			HedgeFlag2;						///< Ͷֵ2
	TAPIMarketLevelType			MarketLevel;					///< м۴
	TAPIYNFLAG					FutureAutoCloseFlag;		    ///< ȨڻǷԶԳ
	TAPISTR_10					UpperChannelNo;					///< ͨ
};

//! ίͲѯӦ
struct TapAPICommodityOrderTypeQryRsp
{
	TapAPICommodity			Commodity;							///< ƷϢ
	TAPIINT32				Count;								///< ί͸
	TAPIOrderTypeType*		OrderTypes;							///< ί׵ַ
};

//! ίЧͲѯӦ
struct TapAPICommodityOrderTimeInForceQryRsp
{
	TapAPICommodity			Commodity;							///< ƷϢ
	TAPIINT32				Count;								///< ίЧ͸
	TAPITimeInForceType*	OrderTimeInForces;					///< ίЧ׵ַ
};


//! ίϢ
struct TapAPIOrderInfo
{
	TAPISTR_20					AccountNo;						///< ͻʽʺ
	TAPISTR_10					ExchangeNo;						///< 
	TAPICommodityType			CommodityType;					///< Ʒ
	TAPISTR_10					CommodityNo;					///< Ʒֱ
	TAPISTR_10					ContractNo;						///< Լ1
	TAPISTR_10					StrikePrice;					///< ִм۸1
	TAPICallOrPutFlagType		CallOrPutFlag;					///< ſ1
	TAPISTR_10					ContractNo2;					///< Լ2
	TAPISTR_10					StrikePrice2;					///< ִм۸2
	TAPICallOrPutFlagType		CallOrPutFlag2;					///< ſ2

	TAPIOrderTypeType			OrderType;						///< ί
	TAPIOrderSourceType			OrderSource;					///< ίԴ
	TAPITimeInForceType			TimeInForce;					///< ίЧ
	TAPIDATETIME				ExpireTime;						///< Ч(GTDʹ)

	TAPIYNFLAG					IsRiskOrder;					///< Ƿձ
	TAPISideType				OrderSide;						///< 
	TAPIPositionEffectType		PositionEffect;					///< ƽ־1
	TAPIPositionEffectType		PositionEffect2;				///< ƽ־2
	TAPISTR_50					InquiryNo;						///< ѯۺ
	TAPIHedgeFlagType			HedgeFlag;						///< Ͷֵ
	TAPIREAL64					OrderPrice;						///< ίм۸1
	TAPIREAL64					OrderPrice2;					///< ίм۸2Ӧʹ
	TAPIREAL64					StopPrice;						///< ۸
	TAPIUINT32					OrderQty;						///< ί
	TAPIUINT32					OrderMinQty;					///< Сɽ
	TAPIUINT32					OrderCanceledQty;				///< 

	TAPIUINT32					MinClipSize;					///< ɽС
	TAPIUINT32					MaxClipSize;					///< ɽ
	TAPISTR_50					LicenseNo;						///< Ȩ

	TAPIINT32					RefInt;							///< Ͳοֵ
	TAPISTR_50					RefString;						///< ַοֵ
	TAPISTR_20					ParentAccountNo;				///< ϼʽ˺

	TAPICHAR					ServerFlag;						///< ʶ
	TAPISTR_20					OrderNo;						///< ίб
	TAPISTR_50                  ClientOrderNo;					///< ͻ˱ίб
	TAPISTR_20					OrderLocalNo;					///< غ
	TAPISTR_50					OrderSystemNo;					///< ϵͳ
	TAPISTR_50					OrderExchangeSystemNo;			///< ϵͳ 
    TAPISTR_20					OrderParentNo;					///< 
	TAPISTR_50					OrderParentSystemNo;			///< ϵͳ
	TAPISTR_10					TradeNo;						///< ױ

	TAPISTR_10					UpperNo;						///< ֺ
	TAPISTR_10					UpperChannelNo;					///< ͨ
	TAPISTR_20					UpperSettleNo;					///< Աź
	TAPISTR_20					UpperUserNo;					///< ֵ¼
	TAPISTR_20					OrderInsertUserNo;				///< µ
	TAPIDATETIME				OrderInsertTime;				///< µʱ
	TAPISTR_20					OrderCommandUserNo;				///< ¼
	TAPISTR_20					OrderUpdateUserNo;				///< ίи
	TAPIDATETIME				OrderUpdateTime;				///< ίиʱ
	TAPIOrderStateType			OrderState;						///< ί״̬
	TAPIREAL64					OrderMatchPrice;				///< ɽ1
	TAPIREAL64					OrderMatchPrice2;				///< ɽ2
	TAPIUINT32					OrderMatchQty;					///< ɽ1
	TAPIUINT32					OrderMatchQty2;					///< ɽ2

	TAPIUINT32					ErrorCode;						///< һβϢ
	TAPISTR_50					ErrorText;						///< Ϣ

	TAPIYNFLAG					IsBackInput;					///< ǷΪ¼ίе
	TAPIYNFLAG					IsDeleted;						///< ίгɽɾ
	TAPIYNFLAG					IsAddOne;						///< ǷΪT+1

	TAPIUINT32					OrderStreamID;					///< ίˮ
	TAPIUINT32					UpperStreamID;					///< 

	TAPIREAL64					ContractSize;					///< ÿֳ
	TAPIREAL64					ContractSize2;					///< ÿֳ
	TAPISTR_10					CommodityCurrencyGroup;			///< Ʒֱ
	TAPISTR_10					CommodityCurrency;				///< Ʒֱ
	TAPICalculateModeType		FeeMode;						///< Ѽ㷽ʽ
	TAPIREAL64					FeeParam;						///< Ѳֵ ѾտѼ
	TAPISTR_10					FeeCurrencyGroup;				///< ͻѱ
	TAPISTR_10					FeeCurrency;					///< ͻѱ
	TAPICalculateModeType		FeeMode2;						///< Ѽ㷽ʽ
	TAPIREAL64					FeeParam2;						///< Ѳֵ ѾտѼ
	TAPISTR_10					FeeCurrencyGroup2;				///< ͻѱ
	TAPISTR_10					FeeCurrency2;					///< ͻѱ
	TAPICalculateModeType		MarginMode;						///< ֤㷽ʽ
	TAPIREAL64					MarginParam;					///< ֵ֤
	TAPICalculateModeType		MarginMode2;					///< ֤㷽ʽ
	TAPIREAL64					MarginParam2;					///< ֵ֤
	TAPIREAL64					PreSettlePrice;					///<   ʽм۵϶ʹ
	TAPIREAL64					PreSettlePrice2;				///<   ʽм۵϶ʹ
	TAPIUINT32					OpenVol;						///< Ԥ ίеĿֲ
	TAPIUINT32					CoverVol;						///< Ԥƽ ίеƽֲ
	TAPIUINT32					OpenVol2;						///< Ԥ ίеĿֲ
	TAPIUINT32					CoverVol2;						///< Ԥƽ ίеƽֲ
	TAPIREAL64					FeeValue;						///< 
	TAPIREAL64					MarginValue;					///< ᱣ֤ ϲĴΪ0
	TAPITacticsTypeType			TacticsType;					///< Ե
	TAPITriggerConditionType	TriggerCondition;				///< 
	TAPITriggerPriceTypeType	TriggerPriceType;				///< ۸
	TAPIYNFLAG					AddOneIsValid;					///< ǷT+1Ч
	TAPIUINT32					OrderQty2;						///< ί2
	TAPIHedgeFlagType			HedgeFlag2;						///< Ͷֵ2
	TAPIMarketLevelType			MarketLevel;					///< м۴
	TAPIYNFLAG					OrderDeleteByDisConnFlag;		///< ʧʱԶʶ
};

//! ֪ͨṹ
struct TapAPIOrderInfoNotice
{
	TAPIUINT32					SessionID;						///< ỰID
	TAPIUINT32					ErrorCode; 						///< 
	TapAPIOrderInfo*			OrderInfo;						///< ίϢ
};

//! Ӧṹ
struct TapAPIOrderActionRsp
{
	TAPIORDERACT				ActionType;						///< 
	TapAPIOrderInfo*			OrderInfo;						///< ίϢ
};


//! ͻĵ
struct TapAPIAmendOrder
{
    TapAPINewOrder              ReqData;                        ///< 
    TAPICHAR					ServerFlag;						///< ʶ
    TAPISTR_20                  OrderNo;                        ///< ίб
};

//! ͻṹ
struct TapAPIOrderCancelReq
{
	TAPIINT32					RefInt;							///< Ͳοֵ
	TAPISTR_50					RefString;						///< ַοֵ
	TAPICHAR					ServerFlag;						///< ʶ
	TAPISTR_20					OrderNo;						///< ίб
};

//! ίṹ
typedef TapAPIOrderCancelReq TapAPIOrderDeactivateReq;

//! ίṹ
typedef TapAPIOrderCancelReq TapAPIOrderActivateReq;

//! ɾίṹ
typedef TapAPIOrderCancelReq TapAPIOrderDeleteReq;

//! ίвѯṹ
struct TapAPIOrderQryReq
{
	TAPIOrderQryTypeType	OrderQryType;	///< ίвѯ
};

//! ί̲ѯ
struct TapAPIOrderProcessQryReq
{
	TAPICHAR					ServerFlag;						///< ʶ
	TAPISTR_20					OrderNo;						///< ίб
};

//! ɽѯṹ
struct TapAPIFillQryReq
{
	TAPIUINT32					StreamID;				    	///< ˮ
};

//! ɽϢ
struct TapAPIFillInfo
{
	TAPISTR_20					AccountNo;						///< ͻʽʺ
	TAPISTR_20					ParentAccountNo;				///< ϼʽ˺
	TAPISTR_10					ExchangeNo;						///< 
	TAPICommodityType			CommodityType;					///< Ʒ
	TAPISTR_10					CommodityNo;					///< Ʒֱ
	TAPISTR_10					ContractNo;						///< Լ1
	TAPISTR_10					StrikePrice;					///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;					///< ſ
	TAPISTR_10					ExchangeNoRef;					///< 
	TAPICommodityType			CommodityTypeRef;				///< Ʒ
	TAPISTR_10					CommodityNoRef;					///< Ʒֱ
	TAPISTR_10					ContractNoRef;					///< Լ
	TAPISTR_10					StrikePriceRef;					///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlagRef;				///< ſ
	TAPISTR_10					OrderExchangeNo;				///< 
	TAPICommodityType			OrderCommodityType;				///< Ʒ
	TAPISTR_10					OrderCommodityNo;				///< Ʒֱ
	TAPIOrderTypeType			OrderType;						///< ί
	TAPIMatchSourceType			MatchSource;					///< ίԴ
	TAPITimeInForceType			TimeInForce;					///< ίЧ
	TAPIDATETIME				ExpireTime;						///< Ч(GTDʹ)
	TAPIYNFLAG					IsRiskOrder;					///< Ƿձ
	TAPISideType				MatchSide;						///< 
	TAPIPositionEffectType		PositionEffect;					///< ƽ־1
	TAPIPositionEffectType		PositionEffectRef;				///< ƽ־2
	TAPIHedgeFlagType			HedgeFlag;						///< Ͷֵ
	TAPICHAR					ServerFlag;						///< ʶ
	TAPISTR_20					OrderNo;						///< ίб
	TAPISTR_20					OrderLocalNo;					///< ίбغ
	TAPISTR_20					MatchNo;						///< سɽ
	TAPISTR_70					ExchangeMatchNo;				///< ɽ
	TAPIDATETIME				MatchDateTime;					///< ɽʱ
	TAPIDATETIME				UpperMatchDateTime;				///< ֳɽʱ
	TAPISTR_10					UpperNo;						///< ֺ
	TAPISTR_10					UpperChannelNo;					///< ͨ
	TAPISTR_20					UpperSettleNo;					///< Աź
	TAPISTR_20					UpperUserNo;					///< ֵ¼
	TAPISTR_10					TradeNo;						///< ױ
	TAPIREAL64					MatchPrice;						///< ɽ
	TAPIUINT32					MatchQty;						///< ɽ
	TAPIYNFLAG					IsBackInput;					///< ǷΪ¼ίе
	TAPIYNFLAG					IsDeleted;						///< ίгɽɾ
	TAPIYNFLAG					IsAddOne;						///< ǷΪT+1
	TAPIUINT32					MatchStreamID;					///< ίˮ
	TAPIUINT32					UpperStreamID;					///< 
	TAPIOpenCloseModeType		OpenCloseMode;                  ///< ƽʽ
	TAPIREAL64					ContractSize;					///< ÿֳ
	TAPISTR_10					CommodityCurrencyGroup;			///< Ʒֱ
	TAPISTR_10					CommodityCurrency;				///< Ʒֱ
	TAPICalculateModeType		FeeMode;						///< Ѽ㷽ʽ
	TAPIREAL64					FeeParam;						///< Ѳֵ ѾտѼ
	TAPISTR_10					FeeCurrencyGroup;				///< ͻѱ
	TAPISTR_10					FeeCurrency;					///< ͻѱ
	TAPIREAL64					PreSettlePrice;					///< 
	TAPIREAL64					FeeValue;						///< 
	TAPIYNFLAG					IsManualFee;					///< ˹ͻѱ
	TAPIREAL64					Turnover;						///< ɽ
	TAPIREAL64					PremiumIncome;					///< Ȩȡ
	TAPIREAL64					PremiumPay;						///< Ȩ֧
	TAPISTR_20					OppoMatchNo;					///< ֱسɽţֺƽֶӦţ
	TAPIREAL64					CloseProfit;					///< ƽӯ
	TAPIREAL64					UnExpProfit;					///< δƽӯ
	TAPIREAL64					UpperMatchPrice;				///< ֳɽ
	TAPIREAL64					QuotePrice;						///< ǰ
	TAPIREAL64					ClosePL;                        ///< ƽӯ
};

//! ƽֲѯṹ
struct TapAPICloseQryReq
{
};

//! ֲֲѯṹ
struct TapAPIPositionQryReq
{
};

//! ֲϢ
struct TapAPIPositionInfo
{
	TAPISTR_20					AccountNo;						///< ͻʽʺ
	TAPISTR_20					ParentAccountNo;				///< ϼʽ˺
	TAPISTR_10					ExchangeNo;						///< 
	TAPICommodityType			CommodityType;					///< Ʒ
	TAPISTR_10					CommodityNo;					///< Ʒֱ
	TAPISTR_10					ContractNo;						///< Լ1
	TAPISTR_10					StrikePrice;					///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;					///< ſ
	TAPISTR_10					ExchangeNoRef;					///< 
	TAPICommodityType			CommodityTypeRef;				///< Ʒ
	TAPISTR_10					CommodityNoRef;					///< Ʒֱ
	TAPISTR_10					ContractNoRef;					///< Լ
	TAPISTR_10					StrikePriceRef;					///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlagRef;				///< ſ
	TAPISTR_10					OrderExchangeNo;				///< 
	TAPICommodityType			OrderCommodityType;				///< Ʒ
	TAPISTR_10					OrderCommodityNo;				///< Ʒֱ
	TAPIOrderTypeType			OrderType;						///< ί
	TAPIMatchSourceType			MatchSource;					///< ίԴ
	TAPITimeInForceType			TimeInForce;					///< ίЧ
	TAPIDATETIME				ExpireTime;						///< Ч(GTDʹ)
	TAPISideType				MatchSide;						///< 
	TAPIHedgeFlagType			HedgeFlag;						///< Ͷֵ
	TAPISTR_70					PositionNo;						///< سֲֺţд
	TAPICHAR					ServerFlag;						///< ʶ
	TAPISTR_20					OrderNo;						///< ίб
	TAPISTR_20					MatchNo;						///< سɽ
	TAPISTR_70					ExchangeMatchNo;				///< ɽ
	TAPIDATE					MatchDate;						///< ɽ
	TAPIDATETIME				MatchTime;						///< ɽʱ
	TAPIDATETIME				UpperMatchTime;					///< ֳɽʱ
	TAPISTR_10					UpperNo;						///< ֺ
	TAPISTR_20					UpperSettleNo;					///< Աź
	TAPISTR_20					UpperUserNo;					///< ֵ¼
	TAPISTR_10					TradeNo;						///< ױ
	TAPIREAL64					PositionPrice;					///< ֲּ
	TAPIUINT32					PositionQty;					///< ֲ
	TAPIYNFLAG					IsBackInput;					///< ǷΪ¼ίе
	TAPIYNFLAG					IsAddOne;						///< ǷΪT+1
	TAPIUINT32					MatchStreamID;					///< ɽˮ
    TAPIUINT32                  PositionStreamId;				///< ֲ
    TAPIOpenCloseModeType       OpenCloseMode;                  ///< ƽʽ
	TAPIREAL64					ContractSize;					///< ÿֳ
	TAPISTR_10					CommodityCurrencyGroup;			///< Ʒֱ
	TAPISTR_10					CommodityCurrency;				///< Ʒֱ
	TAPIREAL64					PreSettlePrice;					///< 
	TAPIREAL64					SettlePrice;					///< ǰ۸
	TAPIREAL64					Turnover;						///< ֲֽ
	TAPICalculateModeType		AccountMarginMode;				///< ֤㷽ʽ
	TAPIREAL64					AccountMarginParam;				///< ֵ֤
	TAPICalculateModeType		UpperMarginMode;				///< ֤㷽ʽ
	TAPIREAL64					UpperMarginParam;				///< ֵ֤
	TAPIREAL64					AccountInitialMargin;			///< ͻʼ֤
	TAPIREAL64					AccountMaintenanceMargin;		///< ͻάֱ֤
	TAPIREAL64					UpperInitialMargin;				///< ֳʼ֤
	TAPIREAL64					UpperMaintenanceMargin;			///< άֱ֤
	TAPIREAL64					PositionProfit;					///< ֲӯ
	TAPIREAL64					LMEPositionProfit;				///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;				///< Ȩֵ
	TAPISTR_20					MatchCmbNo;						///< ϳֲֺ
	TAPIYNFLAG					IsHistory;						///< Ƿʷֲ
	TAPIREAL64					FloatingPL;						///< ʸӯ
};

//! ͻֲӯ
struct TapAPIPositionProfit
{
	TAPISTR_70					PositionNo;						///< سֲֺţд
	TAPIUINT32					PositionStreamId;				///< ֲ
	TAPIREAL64					PositionProfit;					///< ֲӯ
	TAPIREAL64					LMEPositionProfit;				///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;				///< Ȩֵ
	TAPIREAL64					CalculatePrice;					///< ۸
	TAPIREAL64					FloatingPL;						///< ʸӯ
};

//! ͻֲӯ֪ͨ
struct TapAPIPositionProfitNotice
{
	TAPIYNFLAG					IsLast;							///< Ƿһ
	TapAPIPositionProfit*		Data;							///< ͻֲӯϢ
};

//! ƽϢ
struct TapAPICloseInfo
{
	TAPISTR_20					AccountNo;						///< ͻʽʺ
	TAPISTR_20					ParentAccountNo;				///< ϼʽ˺
	TAPISTR_10					ExchangeNo;						///< 
	TAPICommodityType			CommodityType;					///< Ʒ
	TAPISTR_10					CommodityNo;					///< Ʒֱ
	TAPISTR_10					ContractNo;						///< Լ
	TAPISTR_10					StrikePrice;					///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;					///< ſ
	TAPISTR_10					OpenOrderExchangeNo;			///< 
	TAPICommodityType			OpenOrderCommodityType;			///< Ʒ
	TAPISTR_10					OpenOrderCommodityNo;			///< Ʒֱ
	TAPISTR_10					CloseOrderExchangeNo;			///< 
	TAPICommodityType			CloseOrderCommodityType;		///< Ʒ
	TAPISTR_10					CloseOrderCommodityNo;			///< Ʒֱ
	TAPIMatchSourceType			OpenMatchSource;
	TAPIMatchSourceType			CloseMatchSource;
	TAPISideType				CloseSide;						///< ƽһߵ
	TAPIUINT32					CloseQty;						///< ƽֳɽ
	TAPIREAL64					OpenPrice;						///< ֳɽ
	TAPIREAL64					ClosePrice;						///< ƽֳɽ
	TAPICHAR					OpenServerFlag;					///< ʶ
	TAPISTR_20					OpenOrderNo;					///< ίб
	TAPISTR_20					OpenMatchNo;					///< سɽ
	TAPISTR_70					OpenExchangeMatchNo;			///< ɽ
	TAPIDATETIME				OpenMatchDateTime;				///< ɽʱ
	TAPICHAR					CloseServerFlag;				///< ʶ
	TAPISTR_20					CloseOrderNo;					///< ίб
	TAPISTR_20					CloseMatchNo;					///< سɽ
	TAPISTR_70					CloseExchangeMatchNo;			///< ɽ
	TAPIDATETIME				CloseMatchDateTime;				///< ɽʱ
    TAPIUINT32                  CloseStreamId;					///< ƽ
    TAPIOpenCloseModeType		OpenCloseMode;                  ///< ƽʽ
	TAPIREAL64					ContractSize;					///< ÿֳ
	TAPISTR_10					CommodityCurrencyGroup;			///< Ʒֱ
	TAPISTR_10					CommodityCurrency;				///< Ʒֱ
	TAPIREAL64					PreSettlePrice;					///< 
	TAPIREAL64					PremiumIncome;					///< Ȩȡ
	TAPIREAL64					PremiumPay;						///< Ȩ֧
	TAPIREAL64					CloseProfit;					///< ƽӯ
	TAPIREAL64					UnExpProfit;					///< δƽӯ
	TAPIREAL64					ClosePL;                        ///< ƽӯ
};
//! ʽѯ
struct TapAPIFundReq
{
	TAPISTR_20					AccountNo;						///< ͻʽʺ
};
//! ʽ˺ʽϢ
struct TapAPIFundData
{
	TAPISTR_20					AccountNo;						///< ͻʽ˺
	TAPISTR_20					ParentAccountNo;				///< ϼʽ˺
	TAPISTR_10					CurrencyGroupNo;				///< 
	TAPISTR_10					CurrencyNo;						///< ֺ(Ϊձʾʽ)
	TAPIREAL64					TradeRate;						///< ׻
	TAPIFutureAlgType			FutureAlg;                      ///< ڻ㷨
	TAPIOptionAlgType			OptionAlg;                      ///< Ȩ㷨
	TAPIREAL64					PreBalance;						///< ս
	TAPIREAL64					PreUnExpProfit;					///< δƽӯ
	TAPIREAL64					PreLMEPositionProfit;			///< LMEֲƽӯ
	TAPIREAL64					PreEquity;						///< Ȩ
	TAPIREAL64					PreAvailable1;					///< տ
	TAPIREAL64					PreMarketEquity;				///< ֵȨ
	TAPIREAL64					CashInValue;					///< 
	TAPIREAL64					CashOutValue;					///< 
	TAPIREAL64					CashAdjustValue;				///< ʽ
	TAPIREAL64					CashPledged;					///< Ѻʽ
	TAPIREAL64					FrozenFee;						///< 
	TAPIREAL64					FrozenDeposit;					///< ᱣ֤
	TAPIREAL64					AccountFee;						///< ͻѰ
	TAPIREAL64					ExchangeFee;					///< 
	TAPIREAL64					AccountDeliveryFee;				///< ͻ
	TAPIREAL64					PremiumIncome;					///< Ȩȡ
	TAPIREAL64					PremiumPay;						///< Ȩ֧
	TAPIREAL64					CloseProfit;					///< ƽӯ
	TAPIREAL64					DeliveryProfit;					///< ӯ
	TAPIREAL64					UnExpProfit;					///< δƽӯ
	TAPIREAL64					ExpProfit;						///< ƽӯ
	TAPIREAL64					PositionProfit;					///< LMEֲӯ 
	TAPIREAL64					LmePositionProfit;				///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;				///< Ȩֵ
	TAPIREAL64					AccountIntialMargin;			///< ͻʼ֤
	TAPIREAL64					AccountMaintenanceMargin;		///< ͻάֱ֤
	TAPIREAL64					UpperInitalMargin;				///< ֳʼ֤
	TAPIREAL64					UpperMaintenanceMargin;			///< άֱ֤
	TAPIREAL64					Discount;						///< LME
	TAPIREAL64					Balance;						///< ս
	TAPIREAL64					Equity;							///< Ȩ
	TAPIREAL64					Available;						///< տ
	TAPIREAL64					CanDraw;						///< ȡ
	TAPIREAL64					MarketEquity;					///< ˻ֵ
	TAPIREAL64					OriginalCashInOut;				///< ԭʼ
	TAPIREAL64					FloatingPL;						///< ʸӯ
	TAPIREAL64					FrozenRiskFundValue;			///< նʽ
	TAPIREAL64					ClosePL;						///< ƽӯ
	TAPIREAL64					NoCurrencyPledgeValue;          ///< ǻѺ
	TAPIREAL64					PrePledgeValue;                 ///< ڳѺ
	TAPIREAL64					PledgeIn;                       ///< 
	TAPIREAL64					PledgeOut;                      ///< ʳ
	TAPIREAL64					PledgeValue;                    ///< Ѻ
	TAPIREAL64					BorrowValue;                    ///< ý
	TAPIREAL64					SpecialAccountFrozenMargin;     ///< Ʒᱣ֤
	TAPIREAL64					SpecialAccountMargin;           ///< Ʒ֤   
	TAPIREAL64					SpecialAccountFrozenFee;        ///< Ʒ
	TAPIREAL64					SpecialAccountFee;              ///< Ʒ
	TAPIREAL64					SpecialFloatProfit;             ///< Ʒӯ
	TAPIREAL64					SpecialCloseProfit;             ///< Ʒƽӯ
	TAPIREAL64					SpecialFloatPL;                 ///< Ʒʸӯ
	TAPIREAL64					SpecialClosePL;                 ///< Ʒƽӯ
};

//! ƷϢ
struct TapAPICommodityInfo
{
	TAPISTR_10				ExchangeNo;						///< 
	TAPICommodityType		CommodityType;					///< Ʒ
	TAPISTR_10				CommodityNo;					///< Ʒֱ
	TAPISTR_20				CommodityName;					///< Ʒ
	TAPISTR_30				CommodityEngName;				///< ƷӢ
	TAPISTR_10				RelateExchangeNo;				///< Ʒֽ
	TAPICommodityType		RelateCommodityType;			///< ƷƷ
	TAPISTR_10				RelateCommodityNo;				///< ƷƷֱ
	TAPISTR_10				RelateExchangeNo2;				///< Ʒ2
	TAPICommodityType		RelateCommodityType2;			///< Ʒ2Ʒ
	TAPISTR_10				RelateCommodityNo2;				///< Ʒ2Ʒֱ
	TAPISTR_10				TradeCurrency;					///< ױ
	TAPISTR_10				SettleCurrency;					///< 
	TAPIREAL64				ContractSize;					///< ÿֳ
	TAPIMarginCalculateModeType			MarginCalculateMode;			///< ڻ֤ʽ,ֱ'1','2'
	TAPIOptionMarginCalculateModeType	OptionMarginCalculateMode;		///< Ȩ֤ʽ
	TAPIOpenCloseModeType				OpenCloseMode;					///< ƽʽ
	TAPIREAL64				StrikePriceTimes;				///< ִм۸
	TAPIYNFLAG				IsOnlyQuoteCommodity;			///< Ʒ
	TAPIREAL64				CommodityTickSize;				///< С䶯λ
	TAPIINT32				CommodityDenominator;			///< ۷ĸ
	TAPICmbDirectType		CmbDirect;						///< Ϸ
	TAPIINT32				OnlyCanCloseDays;				///< ֻƽǰ
	TAPIDeliveryModeType	DeliveryMode;					///< Ȩʽ
	TAPIINT32				DeliveryDays;					///< ƫ
	TAPITIME				AddOneTime;						///< T+1ָʱ
	TAPIINT32				CommodityTimeZone;				///< Ʒʱ
};

//! ׺ԼϢ
struct TapAPITradeContractInfo
{
	TAPISTR_10              ExchangeNo;                             ///< 
	TAPICommodityType		CommodityType;                          ///< Ʒ
	TAPISTR_10              CommodityNo;                            ///< Ʒֱ
	TAPISTR_10              ContractNo1;                            ///< Լ1
	TAPISTR_10              StrikePrice1;                           ///< ִм1
	TAPICallOrPutFlagType	CallOrPutFlag1;                         ///< ǿʾ1
	TAPISTR_10              ContractNo2;                            ///< Լ2
	TAPISTR_10              StrikePrice2;                           ///< ִм2
	TAPICallOrPutFlagType	CallOrPutFlag2;                         ///< ǿʾ2
	TAPIContractTypeType	ContractType;                           ///< Լ
	TAPISTR_10				QuoteUnderlyingContract;				///< ʵԼ
	TAPISTR_70              ContractName;                           ///< Լ
	TAPIDATE                ContractExpDate;                        ///< Լ	
	TAPIDATE                LastTradeDate;                          ///< 
	TAPIDATE                FirstNoticeDate;                        ///< ״֪ͨ
	TAPISTR_10				FutureContractNo;						///< ڻԼ(Ȩ)
};


//! Ϣ
struct TapAPIDeepQuoteInfo
{
	TAPISideType				Side;							///< 
	TAPIREAL64					Price;							///< ҵ۸
	TAPIUINT32					Qty;							///< ҵ
};

//! ѯӦ
struct TapAPIDeepQuoteQryRsp
{
	TapAPIContract			Contract;							///< Լ
	TapAPIDeepQuoteInfo		DeepQuote;							///< 
};

//! ʱ״̬Ϣѯṹ
struct TapAPIExchangeStateInfoQryReq
{
};

//! ʱ״̬Ϣ
struct TapAPIExchangeStateInfo
{
	TAPISTR_10				UpperChannelNo;			///< ͨ
	TAPISTR_10				ExchangeNo;				///< 
	TAPICommodityType		CommodityType;			///< Ʒ
	TAPISTR_10				CommodityNo;			///< Ʒֱ
	TAPIDATETIME			ExchangeTime;			///< ʱ
	TAPITradingStateType	TradingState;			///< ״̬
};

//! ʱ״̬Ϣ֪ͨṹ
struct TapAPIExchangeStateInfoNotice
{
	TAPIYNFLAG				IsLast;					///< Ƿһ
	TapAPIExchangeStateInfo ExchangeStateInfo;		///< ʱ״̬Ϣ
};

//! ѯ֪ͨṹ
struct TapAPIReqQuoteNotice
{
	TAPISTR_10					ExchangeNo;						///< 
	TAPICommodityType			CommodityType;					///< Ʒ
	TAPISTR_10					CommodityNo;					///< Ʒֱ
	TAPISTR_10					ContractNo;						///< Լ
	TAPISTR_10					StrikePrice;					///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;					///< ſ
	TAPISTR_50					InquiryNo;						///< ѯۺ
	TAPIDATETIME				UpdateTime;						///< ʱ                   
};

//! ͨϢѯṹ
struct TapAPIUpperChannelQryReq
{
};

//! ͨϢṹ
struct TapAPIUpperChannelInfo
{
	TAPISTR_10				UpperChannelNo;			///< ͨ
	TAPISTR_20				UpperChannelName;		///< ͨ
	TAPISTR_10				UpperNo;				///< ͨ
	TAPISTR_20				UpperUserNo;			///< ϯλ
};
//! ͻշʲѯṹ
struct TapAPIAccountRentQryReq
{
    TAPISTR_20                              AccountNo;													//ʽ˻
    TAPISTR_10                              ExchangeNo;													//
	TAPICommodityType			            CommodityType;												//Ʒ
	TAPISTR_10                              CommodityNo;												//Ʒֱ
	TAPISTR_10                              ContractNo;													//Լ 
};
//! ͻշϢṹ
struct	TapAPIAccountRentInfo
{
	TAPISTR_20                              AccountNo;													//ʽ˻
	TAPISTR_10                              ExchangeNo;													//
	TAPICommodityType			            CommodityType;												//Ʒ
	TAPISTR_10                              CommodityNo;												//Ʒֱ
	TAPISTR_10                              ContractNo;													//Լ 
	TAPIMatchSourceType			            MatchSource;												//ɽԴ  
    TAPISTR_10				                CurrencyNo;													//ֱ
	
	TAPICalculateModeType			        FeeMode;                                                    //Ѽ㷽ʽ 
	TAPIREAL64				                OpenTurnover;												//Ѱ
	TAPIREAL64				                ClosedTurnover;												//ƽѰ
	TAPIREAL64				                CloseNewTurnover;											//ƽѰ
	TAPIREAL64				                OpenVolume;													//Ѱ
	TAPIREAL64				                ClosedVolume;												//ƽѰ	
    TAPIREAL64				                CloseNewVolume;												//ƽѰ
	
    TAPICalculateModeType                   MarginMode;                                                 //֤㷽ʽ   
	TAPIREAL64				                BuyTInitMargin;												//Ͷʼ֤
	TAPIREAL64				                SellTInitMargin;											//Ͷʼ֤
	TAPIREAL64				                BuyBInitMargin;												//ֵʼ֤
	TAPIREAL64				                SellBInitMargin;											//ֵʼ֤
	TAPIREAL64				                BuyLInitMargin;												//ʼ֤
	TAPIREAL64				                SellLInitMargin;											//ʼ֤
	TAPIREAL64				                BuyMInitMargin;												//̳ʼ֤
	TAPIREAL64				                SellMInitMargin;											//̳ʼ֤
	TAPIREAL64				                BuyTMaintMargin;											//Ͷάֱ֤
	TAPIREAL64				                SellTMaintMargin;											//Ͷάֱ֤
	TAPIREAL64				                BuyBMaintMargin;											//ֵάֱ֤
	TAPIREAL64				                SellBMaintMargin;											//ֵάֱ֤
	TAPIREAL64				                BuyLMaintMargin;											//άֱ֤
	TAPIREAL64				                SellLMaintMargin;											//άֱ֤
	TAPIREAL64				                BuyMMaintMargin;											//άֱ֤
	TAPIREAL64				                SellMMaintMargin;											//άֱ֤

};

#pragma pack(pop)
#endif //TAP_TRADE_API_DATA_TYPE_H