//=============================================================================
/* ʢͳһAPIӿ
 * ļEsTradeAPI ʹõݽṹ
 * 汾Ϣ:2018-05-21  ļ
 */
//=============================================================================
#ifndef ES_TRADE_API_STRUCT_H
#define ES_TRADE_API_STRUCT_H

#include "EsTradeAPIDataType.h"

namespace EsTradeAPI
{

#pragma pack(push, 1)

//------------------------------------------------------------------------------------------
//! ¼ûϢ
struct TapAPITradeUserInfo
{
	TAPISystemTypeType			SystemType;							///< ̨ϵͳ
	TAPISTR_20					UserNo;								///< û
	TAPISTR_40					LoginIP;							///< ¼IP
	TAPIUINT32					LoginProt;							///< ¼˿
	TAPILoginTypeType			LoginType;							///< ¼
};

//! ¼֤Ϣ
struct TapAPITradeLoginAuth
{
	TAPISTR_20					UserNo;								///< û
	TAPIUserTypeType			UserType;							///< û
	TAPISTR_50					AuthCode;							///< Ȩ
	TAPISTR_30					AppID;								///< 汾
	TAPIYNFLAG					ISModifyPassword;					///< Ƿ޸	
	TAPISTR_20					Password;							///< 
	TAPISTR_20					NewPassword;						///< 
	TAPIYNFLAG					ISDDA;								///< ǷҪ̬֤
	TAPISTR_30					DDASerialNo;						///< ̬֤
	TAPINoticeIgnoreFlagType	NoticeIgnoreFlag;					///< ֪ͨ
    TAPISTR_300                 LoginInfo;                          ///< ֱûд
};

//! ¼Ϣ
struct TapAPITradeLoginRspInfo
{
	TAPISTR_20					UserNo;								///< û
	TAPIUserTypeType			UserType;							///< û
	TAPISTR_20					UserName;							///< û
	TAPISTR_20					QuoteTempPassword;					///< ʱ
	TAPISTR_50					ReservedInfo;						///< ԤϢ
	TAPISTR_40					LastLoginIP;						///< ϴε¼IP
	TAPIUINT32					LastLoginProt;						///< ϴε¼˿
	TAPIDATETIME				LastLoginTime;						///< ϴε¼ʱ
	TAPIDATETIME				LastLogoutTime;						///< ϴ˳ʱ
	TAPIDATE					TradeDate;							///< ǰ
	TAPIDATETIME				LastSettleTime;						///< ϴνʱ
	TAPIDATETIME				StartTime;							///< ϵͳʱ
	TAPIDATETIME				InitTime;							///< ϵͳʼʱ
	TAPIAuthTypeType			AuthType;							///< ûȨ
	TAPIDATETIME				AuthDate;							///< ûȨ
};

//! ¼ɼϢ
struct TapAPISubmitUserLoginInfo
{
	TAPISTR_20					UserNo;								///< ¼û
	TAPISTR_500					GatherInfo;							///< ûնϢ
	TAPISTR_40					ClientLoginIP;						///< ûIP
	TAPIUINT32					ClientLoginPort;					///< ûPort
	TAPIDATETIME				ClientLoginDateTime;				///< û¼ʱ
	TAPISTR_30					ClientAppID;						///< ûAppID
	TAPIUINT32					AuthKeyVersion;						///< ûնϢԿ汾
};

//! ϱû¼ɼϢӦ
struct TapAPISubmitUserLoginInfoRsp
{
	TAPISTR_20					UserNo;								///< ¼û
	TAPIUINT32					ErrorCode;							///< Ϣ
	TAPISTR_50					ErrorText;							///< Ϣ
};

//! Ϣ
struct TapAPIExchangeInfo
{
	TAPISTR_10					ExchangeNo;							///< 
	TAPISTR_20					ExchangeName;						///< 
};

//! Ʒֱṹ
struct TapAPICommodity
{
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
};

//! ƷϢ
struct TapAPICommodityInfo
{
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_20					CommodityName;						///< Ʒ
	TAPISTR_30					CommodityEngName;					///< ƷӢ
	TAPISTR_10					RelateExchangeNo;					///< Ʒֽ
	TAPICommodityType			RelateCommodityType;				///< ƷƷ
	TAPISTR_10					RelateCommodityNo;					///< ƷƷֱ
	TAPISTR_10					RelateExchangeNo2;					///< Ʒ2
	TAPICommodityType			RelateCommodityType2;				///< Ʒ2Ʒ
	TAPISTR_10					RelateCommodityNo2;					///< Ʒ2Ʒֱ
	TAPISTR_10					TradeCurrency;						///< ױ
	TAPIREAL64					ContractSize;						///< ÿֳ
	TAPIOpenCloseModeType		OpenCloseMode;						///< ƽʽ
	TAPIREAL64					StrikePriceTimes;					///< ִм۸
	TAPIREAL64					CommodityTickSize;					///< С䶯λ
	TAPIINT32					CommodityDenominator;				///< ۷ĸ
	TAPICmbDirectType			CmbDirect;							///< Ϸ
	TAPIINT32					OnlyCanCloseDays;					///< ֻƽǰ
	TAPIDeliveryModeType		DeliveryMode;						///< Ȩʽ
	TAPIINT32					DeliveryDays;						///< ƫ
	TAPITIME					AddOneTime;							///< T+1ָʱ
	TAPIINT32					CommodityTimeZone;					///< Ʒʱ
	TAPIIsAddOneType			IsAddOne;							///< ǷT+1ʱ
};

//! Լṹ
struct TapAPIContract
{
	TapAPICommodity				Commodity;							///< Ʒ
	TAPISTR_10					ContractNo1;						///< Լ1
	TAPISTR_10					StrikePrice1;						///< ִм1
	TAPICallOrPutFlagType		CallOrPutFlag1;						///< ǿʾ1
	TAPISTR_10					ContractNo2;						///< Լ2
	TAPISTR_10					StrikePrice2;						///< ִм2
	TAPICallOrPutFlagType		CallOrPutFlag2;						///< ǿʾ2
};

//! ׺ԼϢ
struct TapAPITradeContractInfo
{
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo1;						///< Լ1
	TAPISTR_10					StrikePrice1;						///< ִм1
	TAPICallOrPutFlagType		CallOrPutFlag1;						///< ǿʾ1
	TAPISTR_10					ContractNo2;						///< Լ2
	TAPISTR_10					StrikePrice2;						///< ִм2
	TAPICallOrPutFlagType		CallOrPutFlag2;						///< ǿʾ2
	TAPISTR_70					ContractName;						///< Լ
	TAPIDATE					ContractExpDate;					///< Լ
	TAPIDATE					LastTradeDate;						///< 
	TAPIDATE					FirstNoticeDate;					///< ״֪ͨ
	TAPISTR_10					FutureContractNo;					///< ڻԼ(Ȩ)
};

//! ޸
struct TapAPIChangePasswordReq
{
	TAPISTR_20					OldPassword;						///< 
	TAPISTR_20					NewPassword;						///< 
};

//! ûȨϢ
struct TapAPIUserRightInfo
{
	TAPISTR_20					UserNo;								///< û
	TAPIRightIDType				RightID;							///< ȨID
};

// ûµƵϢ
struct TapAPIUserOrderFrequency
{
	TAPISTR_20					UserNo;								///< û
	TAPIUINT32					UserOrderFrequency;					///< ûƵ
};

//! ˺Ϣѯ
struct TapAPIAccQryReq
{
	TAPISTR_20					AccountNo;							///< ʽ˺				
};

//! ʽ˺Ϣ
struct TapAPIAccountInfo
{
	TAPISTR_20					AccountNo;							///< ʽ˺
	TAPIAccountType				AccountType;						///< ˺
	TAPIAccountState			AccountState;						///< ˺״̬
	TAPISTR_20					AccountShortName;					///< ˺ż
	//TAPIYNFLAG				AccountIsDocHolder;					///< Ƿ֤
	TAPIYNFLAG					IsMarketMaker;						///< Ƿ
	//TAPIAccountFamilyType		AccountFamilyType;					///< ˺
};

//! ͻµṹ
struct TapAPINewOrder
{
	TAPISTR_20					AccountNo;							///< ͻʽʺ
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ1
	TAPISTR_10					StrikePrice;						///< ִм۸1
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ1
	TAPISTR_10					ContractNo2;						///< Լ2
	TAPISTR_10					StrikePrice2;						///< ִм۸2
	TAPICallOrPutFlagType		CallOrPutFlag2;						///< ſ2
	TAPIOrderTypeType			OrderType;							///< ί
	TAPIOrderSourceType			OrderSource;						///< ίԴ
	TAPITimeInForceType			TimeInForce;						///< ίЧ
	TAPIDATETIME				ExpireTime;							///< Ч(GTDʹ)
	TAPIYNFLAG					IsRiskOrder;						///< Ƿձ
	TAPISideType				OrderSide;							///< 
	TAPIPositionEffectType		PositionEffect;						///< ƽ־1
	TAPIPositionEffectType		PositionEffect2;					///< ƽ־2
	TAPISTR_50					InquiryNo;							///< ѯۺ
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ1
	TAPIHedgeFlagType			HedgeFlag2;							///< Ͷֵ2Ӧʹ
	TAPIREAL64					OrderPrice;							///< ίм۸1
	TAPIREAL64					OrderPrice2;						///< ίм۸2Ӧʹ
	TAPIUINT32					OrderQty;							///< ί1
	TAPIUINT32					OrderQty2;							///< ί2Ӧʹ
	TAPIUINT32					OrderMinQty;						///< Сɽ
	TAPIUINT32					MinClipSize;						///< ɽС
	TAPIUINT32					MaxClipSize;						///< ɽ
	TAPIINT32					RefInt;								///< Ͳοֵ
	TAPIREAL64					RefDouble;							///< οֵ()
	TAPISTR_50					RefString;							///< ַοֵ
	TAPITacticsTypeType			TacticsType;						///< Ե
	TAPITriggerConditionType	TriggerCondition;					///< 
	TAPITriggerPriceTypeType	TriggerPriceType;					///< ۸
	TAPIREAL64					StopPrice;							///< ۸
	TAPIYNFLAG					AddOneIsValid;						///< ǷT+1Ч
	TAPIMarketLevelType			MarketLevel;						///< м۴
	TAPIYNFLAG					FutureAutoCloseFlag;				///< ȨڻǷԶԳ
	TAPISTR_10					UpperChannelNo;						///< ͨ
	
	TapAPINewOrder()
	{
		memset(this, 0, sizeof(TapAPINewOrder));
		CallOrPutFlag = TAPI_CALLPUT_FLAG_NONE;
		CallOrPutFlag2 = TAPI_CALLPUT_FLAG_NONE;
		OrderSource = TAPI_ORDER_SOURCE_ESUNNY_API;
		TimeInForce = TAPI_ORDER_TIMEINFORCE_GFD;
		PositionEffect = TAPI_PositionEffect_NONE;
		PositionEffect2 = TAPI_PositionEffect_NONE;
		HedgeFlag = TAPI_HEDGEFLAG_NONE;
		HedgeFlag2 = TAPI_HEDGEFLAG_NONE;
		TacticsType = TAPI_TACTICS_TYPE_NONE;
		TriggerCondition = TAPI_TRIGGER_CONDITION_NONE;
		TriggerPriceType = TAPI_TRIGGER_PRICE_NONE;
		AddOneIsValid = APIYNFLAG_NO;
		FutureAutoCloseFlag = APIYNFLAG_NO;
	}
};

//! ίϢ
struct TapAPIOrderInfo
{
	TAPISTR_20					AccountNo;							///< ͻʽʺ
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ1
	TAPISTR_10					StrikePrice;						///< ִм۸1
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ1
	TAPISTR_10					ContractNo2;						///< Լ2
	TAPISTR_10					StrikePrice2;						///< ִм۸2
	TAPICallOrPutFlagType		CallOrPutFlag2;						///< ſ2
	TAPIOrderTypeType			OrderType;							///< ί
	TAPIOrderSourceType			OrderSource;						///< ίԴ
	TAPITimeInForceType			TimeInForce;						///< ίЧ
	TAPIDATETIME				ExpireTime;							///< Ч(GTDʹ)
	TAPIYNFLAG					IsRiskOrder;						///< Ƿձ
	TAPISideType				OrderSide;							///< 
	TAPIPositionEffectType		PositionEffect;						///< ƽ־1
	TAPIPositionEffectType		PositionEffect2;					///< ƽ־2Ӧʹ
	TAPISTR_50					InquiryNo;							///< ѯۺ
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ1
	TAPIHedgeFlagType			HedgeFlag2;							///< Ͷֵ2Ӧʹ
	TAPIREAL64					OrderPrice;							///< ίм۸1
	TAPIREAL64					OrderPrice2;						///< ίм۸2Ӧʹ
	TAPIREAL64					StopPrice;							///< ۸
	TAPIUINT32					OrderQty;							///< ί1
	TAPIUINT32					OrderQty2;							///< ί2Ӧʹ
	TAPIUINT32					OrderMinQty;						///< Сɽ
	TAPIUINT32					MinClipSize;						///< ɽС
	TAPIUINT32					MaxClipSize;						///< ɽ
	TAPIINT32					RefInt;								///< Ͳοֵ
	TAPIREAL64					RefDouble;							///< οֵ
	TAPISTR_50					RefString;							///< ַοֵ
	TAPITacticsTypeType			TacticsType;						///< Ե
	TAPITriggerConditionType	TriggerCondition;					///< 
	TAPITriggerPriceTypeType	TriggerPriceType;					///< ۸
	TAPIYNFLAG					AddOneIsValid;						///< ǷT+1Ч
	TAPIMarketLevelType			MarketLevel;						///< м۴
	TAPIYNFLAG					FutureAutoCloseFlag;				///< ȨڻǷԶԳ
	
	TAPIUINT32					OrderCanceledQty;					///< 
	TAPISTR_50					LicenseNo;							///< Ȩ
	TAPISTR_20					ParentAccountNo;					///< ϼʽ˺

	TAPICHAR					ServerFlag;							///< ʶ
	TAPISTR_20					OrderNo;							///< ίб
	TAPISTR_50                  ClientOrderNo;						///< ͻ˱ίб
	TAPISTR_20					OrderLocalNo;						///< غ
	TAPISTR_50					OrderSystemNo;						///< ϵͳ
	TAPISTR_50					OrderExchangeSystemNo;				///< ϵͳ 
    //TAPISTR_20				OrderParentNo;						///< 
	//TAPISTR_50				OrderParentSystemNo;				///< ϵͳ
	TAPISTR_10					TradeNo;							///< ױ

	TAPISTR_10					UpperNo;							///< ֺ
	TAPISTR_10					UpperChannelNo;						///< ͨ
	TAPISTR_20					UpperSettleNo;						///< Աź
	TAPISTR_20					UpperUserNo;						///< ֵ¼
	TAPISTR_20					OrderInsertUserNo;					///< µ
	TAPIDATETIME				OrderInsertTime;					///< µʱ
	TAPISTR_20					OrderCommandUserNo;					///< ¼
	TAPISTR_20					OrderUpdateUserNo;					///< ίи
	TAPIDATETIME				OrderUpdateTime;					///< ίиʱ
	TAPIOrderStateType			OrderState;							///< ί״̬
	TAPIREAL64					OrderMatchPrice;					///< ɽ1
	TAPIREAL64					OrderMatchPrice2;					///< ɽ2
	TAPIUINT32					OrderMatchQty;						///< ɽ1
	TAPIUINT32					OrderMatchQty2;						///< ɽ2

	TAPIUINT32					ErrorCode;							///< һβϢ
	TAPISTR_50					ErrorText;							///< Ϣ

	TAPIYNFLAG					IsBackInput;						///< ǷΪ¼ίе
	TAPIYNFLAG					IsDeleted;							///< ίгɽɾ
	TAPIYNFLAG					IsAddOne;							///< ǷΪT+1

	TAPIUINT32					OrderStreamID;						///< ίˮ
	//TAPIUINT32				UpperStreamID;						///< 

	//TAPIREAL64				ContractSize;						///< ÿֳ
	//TAPIREAL64				ContractSize2;						///< ÿֳ
	//TAPISTR_10				CommodityCurrencyGroup;				///< Ʒֱ
	//TAPISTR_10				CommodityCurrency;					///< Ʒֱ
	//TAPICalculateModeType		FeeMode;							///< Ѽ㷽ʽ
	//TAPIREAL64				FeeParam;							///< Ѳֵ ѾտѼ
	//TAPISTR_10				FeeCurrencyGroup;					///< ͻѱ
	//TAPISTR_10				FeeCurrency;						///< ͻѱ
	//TAPICalculateModeType		FeeMode2;							///< Ѽ㷽ʽ
	//TAPIREAL64				FeeParam2;							///< Ѳֵ ѾտѼ
	//TAPISTR_10				FeeCurrencyGroup2;					///< ͻѱ
	//TAPISTR_10				FeeCurrency2;						///< ͻѱ
	//TAPICalculateModeType		MarginMode;							///< ֤㷽ʽ
	//TAPIREAL64				MarginParam;						///< ֵ֤
	//TAPICalculateModeType		MarginMode2;						///< ֤㷽ʽ
	//TAPIREAL64				MarginParam2;						///< ֵ֤
	//TAPIREAL64				PreSettlePrice;						///<   ʽм۵϶ʹ
	//TAPIREAL64				PreSettlePrice2;					///<   ʽм۵϶ʹ
	//TAPIUINT32				OpenVol;							///< Ԥ ίеĿֲ
	//TAPIUINT32				CoverVol;							///< Ԥƽ ίеƽֲ
	//TAPIUINT32				OpenVol2;							///< Ԥ ίеĿֲ
	//TAPIUINT32				CoverVol2;							///< Ԥƽ ίеƽֲ
	TAPIREAL64					FeeValue;							///< 
	TAPIREAL64					MarginValue;						///< ᱣ֤ ϲĴΪ0
	TAPIYNFLAG					OrderDeleteByDisConnFlag;			///< ʧʱԶʶ
	
	TapAPIOrderInfo()
	{
		memset(this, 0, sizeof(TapAPIOrderInfo));
		CallOrPutFlag = TAPI_CALLPUT_FLAG_NONE;
		CallOrPutFlag2 = TAPI_CALLPUT_FLAG_NONE;
		OrderSource = TAPI_ORDER_SOURCE_ESUNNY_API;
		TimeInForce = TAPI_ORDER_TIMEINFORCE_GFD;
		PositionEffect = TAPI_PositionEffect_NONE;
		PositionEffect2 = TAPI_PositionEffect_NONE;
		HedgeFlag = TAPI_HEDGEFLAG_NONE;
		HedgeFlag2 = TAPI_HEDGEFLAG_NONE;
		TacticsType = TAPI_TACTICS_TYPE_NONE;
		AddOneIsValid = APIYNFLAG_NO;
		FutureAutoCloseFlag = APIYNFLAG_NO;
		IsBackInput = APIYNFLAG_NO;
		IsAddOne = APIYNFLAG_NO;
		IsDeleted = APIYNFLAG_NO;
		OrderDeleteByDisConnFlag = APIYNFLAG_NO;
	}
};

//! Ӧṹ
struct TapAPIOrderActionRsp
{
	TAPIORDERACT				ActionType;							///< 
	TapAPIOrderInfo*			OrderInfo;							///< ίϢ
};

//! ͻĵ
//! ServerFlagOrderNo,Լίмۺίֶֹۡʱûá
struct TapAPIOrderModifyReq
{
    TapAPINewOrder				ReqData;							///< 
    TAPICHAR					ServerFlag;							///< ʶ
    TAPISTR_20					OrderNo;							///< ίб
public:
	TapAPIOrderModifyReq()
	{
		memset(this, 0, sizeof(TapAPIOrderModifyReq));
	}
};

//! ͻṹ
//! ServerFlagOrderNo.
struct TapAPIOrderCancelReq
{
	TAPIINT32					RefInt;								///< Ͳοֵ
	TAPISTR_50					RefString;							///< ַοֵ
	TAPICHAR					ServerFlag;							///< ʶ
	TAPISTR_20					OrderNo;							///< ίб
};

//! ίṹ
typedef TapAPIOrderCancelReq TapAPIOrderDeactivateReq;

//! ίṹ
typedef TapAPIOrderCancelReq TapAPIOrderActivateReq;

//! ɾίṹ
typedef TapAPIOrderCancelReq TapAPIOrderDeleteReq;

//! ίвѯṹ
struct TapAPIOrderQryReq
{
	TAPIOrderQryTypeType		OrderQryType;						///< ίвѯ
	TAPISTR_20					AccountNo;							///< ͻʽʺţղûпͻ
	TAPIUINT32					DataSeqID;							///< ʼ
};

//! ί̲ѯ
struct TapAPIOrderProcessQryReq
{
	TAPICHAR					ServerFlag;							///< ʶ
	TAPISTR_20					OrderNo;							///< ίб
};

//! ɽѯṹ
struct TapAPIFillQryReq
{
	TAPISTR_20					AccountNo;							///< ͻʽʺţղûпͻ
	TAPIUINT32					DataSeqID;							///< ʼ
};

//! ɽϢ
struct TapAPIFillInfo
{
	TAPISTR_20					AccountNo;							///< ͻʽʺ
	//TAPISTR_20				ParentAccountNo;					///< ϼʽ˺
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ1
	TAPISTR_10					StrikePrice;						///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ
	//TAPISTR_10				ExchangeNoRef;						///< 
	//TAPICommodityType			CommodityTypeRef;					///< Ʒ
	//TAPISTR_10				CommodityNoRef;						///< Ʒֱ
	//TAPISTR_10				ContractNoRef;						///< Լ
	//TAPISTR_10				StrikePriceRef;						///< ִм۸
	//TAPICallOrPutFlagType		CallOrPutFlagRef;					///< ſ
	//TAPISTR_10				OrderExchangeNo;					///< 
	//TAPICommodityType			OrderCommodityType;					///< Ʒ
	//TAPISTR_10				OrderCommodityNo;					///< Ʒֱ
	TAPIOrderTypeType			OrderType;							///< ί
	TAPIMatchSourceType			MatchSource;						///< ίԴ
	TAPITimeInForceType			TimeInForce;						///< ίЧ
	TAPIDATETIME				ExpireTime;							///< Ч(GTDʹ)
	TAPIYNFLAG					IsRiskOrder;						///< Ƿձ
	TAPISideType				MatchSide;							///< 
	TAPIPositionEffectType		PositionEffect;						///< ƽ־1
	//TAPIPositionEffectType	PositionEffectRef;					///< ƽ־2
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ
	TAPICHAR					ServerFlag;							///< ʶ
	TAPISTR_20					OrderNo;							///< ίб
	TAPISTR_20					OrderLocalNo;						///< ίбغ
	TAPISTR_20					MatchNo;							///< سɽ
	TAPISTR_70					ExchangeMatchNo;					///< ɽ
	TAPIDATETIME				MatchDateTime;						///< ɽʱ
	TAPIDATETIME				UpperMatchDateTime;					///< ֳɽʱ
	TAPISTR_10					UpperNo;							///< ֺ
	TAPISTR_10					UpperChannelNo;						///< ͨ
	TAPISTR_20					UpperSettleNo;						///< Աź
	TAPISTR_20					UpperUserNo;						///< ֵ¼
	TAPISTR_10					TradeNo;							///< ױ
	TAPIREAL64					MatchPrice;							///< ɽ
	TAPIUINT32					MatchQty;							///< ɽ
	TAPIYNFLAG					IsBackInput;						///< ǷΪ¼ίе
	TAPIYNFLAG					IsDeleted;							///< ίгɽɾ
	TAPIYNFLAG					IsAddOne;							///< ǷΪT+1
	TAPIUINT32					MatchStreamID;						///< ίˮ
	//TAPIUINT32				UpperStreamID;						///< 
	TAPIOpenCloseModeType		OpenCloseMode;						///< ƽʽ
	TAPIREAL64					ContractSize;						///< ÿֳ
	TAPISTR_10					CommodityCurrencyGroup;				///< Ʒֱ
	TAPISTR_10					CommodityCurrency;					///< Ʒֱ
	//TAPICalculateModeType		FeeMode;							///< Ѽ㷽ʽ
	//TAPIREAL64				FeeParam;							///< Ѳֵ ѾտѼ
	TAPISTR_10					FeeCurrencyGroup;					///< ͻѱ
	TAPISTR_10					FeeCurrency;						///< ͻѱ
	TAPIREAL64					PreSettlePrice;						///< 
	TAPIREAL64					FeeValue;							///< 
	TAPIYNFLAG					IsManualFee;						///< ˹ͻѱ
	//TAPIREAL64				Turnover;							///< ɽ
	TAPIREAL64					PremiumIncome;						///< Ȩȡ
	TAPIREAL64					PremiumPay;							///< Ȩ֧
	//TAPISTR_20				OppoMatchNo;						///< ֱسɽţֺƽֶӦţ
	TAPIREAL64					CloseProfit;						///< ƽӯ
	TAPIREAL64					UnExpProfit;						///< δƽӯ
	//TAPIREAL64				UpperMatchPrice;					///< ֳɽ
	//TAPIREAL64				QuotePrice;							///< ǰ
	TAPIREAL64					ClosePL;							///< ƽӯ
};

//! ֲֲѯṹ
struct TapAPIPositionQryReq
{
	TAPISTR_20					AccountNo;							///< ͻʽʺţղûпͻ
	TAPIUINT32					DataSeqID;							///< ʼ
};

//! ֲϢ
struct TapAPIPositionInfo
{
	TAPISTR_20					AccountNo;							///< ͻʽʺ
	//TAPISTR_20				ParentAccountNo;					///< ϼʽ˺
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ1
	TAPISTR_10					StrikePrice;						///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ
	//TAPISTR_10				ExchangeNoRef;						///< 
	//TAPICommodityType			CommodityTypeRef;					///< Ʒ
	//TAPISTR_10				CommodityNoRef;						///< Ʒֱ
	//TAPISTR_10				ContractNoRef;						///< Լ
	//TAPISTR_10				StrikePriceRef;						///< ִм۸
	//TAPICallOrPutFlagType		CallOrPutFlagRef;					///< ſ
	//TAPISTR_10				OrderExchangeNo;					///< 
	//TAPICommodityType			OrderCommodityType;					///< Ʒ
	//TAPISTR_10				OrderCommodityNo;					///< Ʒֱ
	//TAPIOrderTypeType			OrderType;							///< ί
	//TAPITimeInForceType		TimeInForce;						///< ίЧ
	//TAPIDATETIME				ExpireTime;							///< Ч(GTDʹ)
	TAPISideType				MatchSide;							///< 
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ
	TAPISTR_70					PositionNo;							///< سֲֺţд
	TAPICHAR					ServerFlag;							///< ʶ
	TAPISTR_20					OrderNo;							///< ίб
	TAPISTR_20					MatchNo;							///< سɽ
	TAPISTR_70					ExchangeMatchNo;					///< ɽ
	TAPIMatchSourceType			MatchSource;						///< ίԴ
	//TAPIDATE					MatchDate;							///< ɽ
	//TAPIDATETIME				MatchTime;							///< ɽʱ
	//TAPIDATETIME				UpperMatchTime;						///< ֳɽʱ
	TAPISTR_10					UpperNo;							///< ֺ
	TAPISTR_20					UpperSettleNo;						///< Աź
	TAPISTR_20					UpperUserNo;						///< ֵ¼
	TAPISTR_10					TradeNo;							///< ױ
	TAPIREAL64					PositionPrice;						///< ֲּ
	TAPIUINT32					PositionQty;						///< ֲ
	TAPIYNFLAG					IsBackInput;						///< ǷΪ¼ίе
	TAPIYNFLAG					IsAddOne;							///< ǷΪT+1
	TAPIUINT32					MatchStreamID;						///< ɽˮ
    TAPIUINT32					PositionStreamId;					///< ֲ
    //TAPIOpenCloseModeType		OpenCloseMode;					    ///< ƽʽ
	TAPIREAL64					ContractSize;						///< ÿֳ
	TAPISTR_10					CommodityCurrencyGroup;				///< Ʒֱ
	TAPISTR_10					CommodityCurrency;					///< Ʒֱ
	TAPIREAL64					PreSettlePrice;						///< 
	//TAPIREAL64				SettlePrice;						///< ǰ۸
	TAPIREAL64					Turnover;							///< ֲֽ
	TAPICalculateModeType		AccountMarginMode;					///< ֤㷽ʽ
	TAPIREAL64					AccountMarginParam;					///< ֵ֤
	//TAPICalculateModeType		UpperMarginMode;					///< ֤㷽ʽ
	//TAPIREAL64				UpperMarginParam;					///< ֵ֤
	TAPIREAL64					AccountInitialMargin;				///< ͻʼ֤
	TAPIREAL64					AccountMaintenanceMargin;			///< ͻάֱ֤
	//TAPIREAL64				UpperInitialMargin;					///< ֳʼ֤
	//TAPIREAL64				UpperMaintenanceMargin;				///< άֱ֤
	TAPIREAL64					PositionProfit;						///< ֲӯ
	TAPIREAL64					LMEPositionProfit;					///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;					///< Ȩֵ
	TAPISTR_20					MatchCmbNo;							///< ϳֲֺ
	TAPIYNFLAG					IsHistory;							///< Ƿʷֲ
	TAPIREAL64					FloatingPL;							///< ʸӯ
	TAPIREAL64					CalculatePrice;						///< ۸
	
	TapAPIPositionInfo()
	{
		memset(this, 0, sizeof(TapAPIPositionInfo));
		IsBackInput = APIYNFLAG_NO;
		IsAddOne = APIYNFLAG_NO;
		IsHistory = APIYNFLAG_NO;
	}
};

//! ͻֲӯ
struct TapAPIPositionProfit
{
	TAPISTR_70					PositionNo;							///< سֲֺţд
	TAPIUINT32					PositionStreamId;					///< ֲ
	TAPIREAL64					PositionProfit;						///< ֲӯ
	TAPIREAL64					LMEPositionProfit;					///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;					///< Ȩֵ
	TAPIREAL64					CalculatePrice;						///< ۸
	TAPIREAL64					FloatingPL;							///< ʸӯ
};

//! ͻֲӯ֪ͨ
struct TapAPIPositionProfitNotice
{
	TAPIYNFLAG					IsLast;								///< Ƿһ
	TapAPIPositionProfit*		Data;								///< ͻֲӯϢ
};

//! ƽֲѯṹ
struct TapAPICloseQryReq
{
	TAPISTR_20					AccountNo;							///< ͻʽʺţղûпͻ
	TAPIUINT32					DataSeqID;							///< ʼ
};

//! ƽϢ
struct TapAPICloseInfo
{
	TAPISTR_20					AccountNo;							///< ͻʽʺ
	//TAPISTR_20				ParentAccountNo;					///< ϼʽ˺
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ
	TAPISTR_10					StrikePrice;						///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ
	//TAPISTR_10				OpenOrderExchangeNo;				///< 
	//TAPICommodityType			OpenOrderCommodityType;				///< Ʒ
	//TAPISTR_10				OpenOrderCommodityNo;				///< Ʒֱ
	//TAPISTR_10				CloseOrderExchangeNo;				///< 
	//TAPICommodityType			CloseOrderCommodityType;			///< Ʒ
	//TAPISTR_10				CloseOrderCommodityNo;				///< Ʒֱ
	TAPIMatchSourceType			OpenMatchSource;
	TAPIMatchSourceType			CloseMatchSource;
	TAPISideType				CloseSide;							///< ƽһߵ
	TAPIUINT32					CloseQty;							///< ƽֳɽ
	TAPIREAL64					OpenPrice;							///< ֳɽ
	TAPIREAL64					ClosePrice;							///< ƽֳɽ
	TAPICHAR					OpenServerFlag;						///< ʶ
	TAPISTR_20					OpenOrderNo;						///< ίб
	TAPISTR_20					OpenMatchNo;						///< سɽ
	TAPISTR_70					OpenExchangeMatchNo;				///< ɽ
	TAPIDATETIME				OpenMatchDateTime;					///< ɽʱ
	TAPICHAR					CloseServerFlag;					///< ʶ
	TAPISTR_20					CloseOrderNo;						///< ίб
	TAPISTR_20					CloseMatchNo;						///< سɽ
	TAPISTR_70					CloseExchangeMatchNo;				///< ɽ
	TAPIDATETIME				CloseMatchDateTime;					///< ɽʱ
    TAPIUINT32                  CloseStreamId;						///< ƽ
    //TAPIOpenCloseModeType		OpenCloseMode;					    ///< ƽʽ
	TAPIREAL64					ContractSize;						///< ÿֳ
	//TAPISTR_10				CommodityCurrencyGroup;				///< Ʒֱ
	//TAPISTR_10				CommodityCurrency;					///< Ʒֱ
	TAPIREAL64					PreSettlePrice;						///< 
	//TAPIREAL64				PremiumIncome;						///< Ȩȡ
	//TAPIREAL64				PremiumPay;							///< Ȩ֧
	TAPIREAL64					CloseProfit;						///< ƽӯ
	TAPIREAL64					UnExpProfit;						///< δƽӯ
	TAPIREAL64					ClosePL;							///< ƽӯ
};

//! ʽѯ
struct TapAPIFundReq
{
	TAPISTR_20					AccountNo;							///< ͻʽʺ
	TAPIUINT32					DataSeqID;							///< ݲѯʼţ1ʾһݣβѯŵݣ
};

//! ʽ˺ʽϢ
struct TapAPIFundData
{
	TAPISTR_20					AccountNo;							///< ͻʽ˺
	//TAPISTR_20				ParentAccountNo;					///< ϼʽ˺
	TAPISTR_10					CurrencyGroupNo;					///< 
	TAPISTR_10					CurrencyNo;							///< ֺ(Ϊձʾʽ)
	TAPIREAL64					TradeRate;							///< ׻
	TAPIFutureAlgType			FutureAlg;							///< ڻ㷨
	TAPIOptionAlgType			OptionAlg;							///< Ȩ㷨
	TAPIREAL64					PreBalance;							///< ս
	TAPIREAL64					PreUnExpProfit;						///< δƽӯ
	TAPIREAL64					PreLMEPositionProfit;				///< LMEֲƽӯ
	TAPIREAL64					PreEquity;							///< Ȩ
	TAPIREAL64					PreAvailable1;						///< տ
	TAPIREAL64					PreMarketEquity;					///< ֵȨ
	TAPIREAL64					CashInValue;						///< 
	TAPIREAL64					CashOutValue;						///< 
	TAPIREAL64					CashAdjustValue;					///< ʽ
	TAPIREAL64					CashPledged;						///< Ѻʽ
	TAPIREAL64					FrozenFee;							///< 
	TAPIREAL64					FrozenDeposit;						///< ᱣ֤
	TAPIREAL64					AccountFee;							///< ͻѰ
	TAPIREAL64					ExchangeFee;						///< 
	TAPIREAL64					AccountDeliveryFee;					///< ͻ
	TAPIREAL64					PremiumIncome;						///< Ȩȡ
	TAPIREAL64					PremiumPay;							///< Ȩ֧
	TAPIREAL64					CloseProfit;						///< ƽӯ
	TAPIREAL64					DeliveryProfit;						///< ӯ
	TAPIREAL64					UnExpProfit;						///< δƽӯ
	TAPIREAL64					ExpProfit;							///< ƽӯ
	TAPIREAL64					PositionProfit;						///< LMEֲӯ 
	TAPIREAL64					LmePositionProfit;					///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;					///< Ȩֵ
	TAPIREAL64					AccountInitialMargin;				///< ͻʼ֤
	TAPIREAL64					AccountMaintenanceMargin;			///< ͻάֱ֤
	TAPIREAL64					UpperInitialMargin;					///< ֳʼ֤
	TAPIREAL64					UpperMaintenanceMargin;				///< άֱ֤
	TAPIREAL64					Discount;							///< LME
	TAPIREAL64					Balance;							///< ս
	TAPIREAL64					Equity;								///< Ȩ
	TAPIREAL64					Available;							///< տ
	TAPIREAL64					CanDraw;							///< ȡ
	TAPIREAL64					MarketEquity;						///< ˻ֵ
	TAPIREAL64					AuthMoney;							///< ʽ
	TAPIREAL64					OriginalCashInOut;					///< ԭʼ
	TAPIREAL64					FloatingPL;							///< ʸӯ
	TAPIREAL64					FrozenRiskFundValue;				///< նʽ
	TAPIREAL64					ClosePL;							///< ƽӯ
	TAPIREAL64					NoCurrencyPledgeValue;				///< ǻѺ
	TAPIREAL64					PrePledgeValue;						///< ڳѺ
	TAPIREAL64					PledgeIn;							///< 
	TAPIREAL64					PledgeOut;							///< ʳ
	TAPIREAL64					PledgeValue;						///< Ѻ
	TAPIREAL64					BorrowValue;						///< ý
	TAPIREAL64					SpecialAccountFrozenMargin;			///< Ʒᱣ֤
	TAPIREAL64					SpecialAccountMargin;				///< Ʒ֤   
	TAPIREAL64					SpecialAccountFrozenFee;			///< Ʒ
	TAPIREAL64					SpecialAccountFee;					///< Ʒ
	TAPIREAL64					SpecialFloatProfit;					///< Ʒӯ
	TAPIREAL64					SpecialCloseProfit;					///< Ʒƽӯ
	TAPIREAL64					SpecialFloatPL;						///< Ʒʸӯ
	TAPIREAL64					SpecialClosePL;						///< Ʒƽӯ
	TAPIREAL64					RiskRate;							///< 
};

//! ѯ֪ͨṹ
struct TapAPIReqQuoteNotice
{
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ
	TAPISTR_10					StrikePrice;						///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ
	TAPISTR_50					InquiryNo;							///< ѯۺ
	TAPIDATETIME				UpdateTime;							///< ʱ                   
};

//! Ϣ(ר)
struct TapAPIDeepQuoteInfo
{
	TAPISideType				Side;								///< 
	TAPIREAL64					Price;								///< ҵ۸
	TAPIUINT32					Qty;								///< ҵ
};

//! ѯӦ(ר)
struct TapAPIDeepQuoteQryRsp
{
	TapAPIContract				Contract;							///< Լ
	TapAPIDeepQuoteInfo			DeepQuote;							///< 
};

//! ʱ״̬Ϣѯṹ(ר)
struct TapAPIExchangeStateInfoQryReq
{
};

//! ʱ״̬Ϣ(ר)
struct TapAPIExchangeStateInfo
{
	TAPISTR_10					UpperChannelNo;						///< ͨ
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPIDATETIME				ExchangeTime;						///< ʱ
	TAPITradingStateType		TradingState;						///< ״̬
};

//! ʱ״̬Ϣ֪ͨṹ(ר)
struct TapAPIExchangeStateInfoNotice
{
	TAPIYNFLAG					IsLast;								///< Ƿһ
	TapAPIExchangeStateInfo		ExchangeStateInfo;					///< ʱ״̬Ϣ
};

//! ͨϢѯṹ(ר)
struct TapAPIUpperChannelQryReq
{
};

//! ͨϢṹ(ר)
struct TapAPIUpperChannelInfo
{
	TAPISTR_10					UpperChannelNo;						///< ͨ
	TAPISTR_20					UpperChannelName;					///< ͨ
	TAPISTR_10					UpperNo;							///< ͨ
	TAPISTR_20					UpperUserNo;						///< ϯλ
};

//! ͻշʲѯṹ
struct TapAPIAccountRentQryReq
{
    TAPISTR_20					AccountNo;							///< ʽ˻
    TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ 
};

//! ͻշϢṹ
struct	TapAPIAccountRentInfo
{
	TAPISTR_20					AccountNo;							///< ʽ˻
	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ 
	TAPIMatchSourceType			MatchSource;						///< ɽԴ  
    TAPISTR_10					CurrencyNo;							///< ֱ
	
	TAPICalculateModeType		FeeMode;							///< Ѽ㷽ʽ 
	TAPIREAL64					OpenTurnover;						///< Ѱ
	TAPIREAL64					ClosedTurnover;						///< ƽѰ
	TAPIREAL64					CloseNewTurnover;					///< ƽѰ
	TAPIREAL64					OpenVolume;							///< Ѱ
	TAPIREAL64					ClosedVolume;						///< ƽѰ	
    TAPIREAL64					CloseNewVolume;						///< ƽѰ
	
    TAPICalculateModeType		MarginMode;							///< ֤㷽ʽ   
	TAPIREAL64					BuyTInitMargin;						///< Ͷʼ֤
	TAPIREAL64					SellTInitMargin;					///< Ͷʼ֤
	TAPIREAL64					BuyBInitMargin;						///< ֵʼ֤
	TAPIREAL64					SellBInitMargin;					///< ֵʼ֤
	TAPIREAL64					BuyLInitMargin;						///< ʼ֤
	TAPIREAL64					SellLInitMargin;					///< ʼ֤
	TAPIREAL64					BuyMInitMargin;						///< ̳ʼ֤
	TAPIREAL64					SellMInitMargin;					///< ̳ʼ֤
	TAPIREAL64					BuyTMaintMargin;					///< Ͷάֱ֤
	TAPIREAL64					SellTMaintMargin;					///< Ͷάֱ֤
	TAPIREAL64					BuyBMaintMargin;					///< ֵάֱ֤
	TAPIREAL64					SellBMaintMargin;					///< ֵάֱ֤
	TAPIREAL64					BuyLMaintMargin;					///< άֱ֤
	TAPIREAL64					SellLMaintMargin;					///< άֱ֤
	TAPIREAL64					BuyMMaintMargin;					///< άֱ֤
	TAPIREAL64					SellMMaintMargin;					///< άֱ֤
};

//! ױϢ(ר)
struct TapAPICurrencyInfo
{
	TAPISTR_10					CurrencyNo;						///< ֱ
	TAPISTR_10					CurrencyGroupNo;				///< 
	TAPIREAL64					TradeRate;						///< ׻
	TAPIREAL64					TradeRate2;						///< ׻2

	TAPIFutureAlgType			FutureAlg;						///< '1', '2'
	TAPIOptionAlgType			OptionAlg;						///< Ȩ㷨,ڻʽ'1',Ȩʽ'2'
};

//! Ϣѯṹ(ǡר)
struct TapAPITradeMessageQryReq
{
    TAPIUINT32					SerialID;						///< 
    TAPIMsgQryTypeType          TradeMsgQryType;                ///< ѯ(רãĬΪȫ)
	TAPISTR_20					AccountNo;						///< ͻʽ˺
    TAPIDATETIME                BeginSendDateTime;              ///< ʼʱ
    TAPIDATETIME                EndSendDateTime;                ///< ʱ
};

//! Ϣṹ(ǡר)
struct TapAPITradeMessage
{
	TAPIUINT32					SerialID;						///< 
	TAPISTR_20					AccountNo;						///< ͻʽ˺

	TAPIDATETIME				TMsgValidDateTime;				///< ϢЧʱ
	TAPISTR_50					TMsgTitle;						///< Ϣ
	TAPISTR_500					TMsgContent;					///< Ϣ
	TAPIMsgTypeType				TMsgType;						///< Ϣ
	TAPIMsgLevelType			TMsgLevel;						///< Ϣ

	TAPIYNFLAG					IsSendBySMS;					///< ǷͶ
	TAPIYNFLAG					IsSendByEMail;					///< Ƿʼ
	TAPISTR_20					Sender;							///<
	TAPIDATETIME				SendDateTime;					///< ʱ
};

//! ͻʽѯṹ(ר)
struct TapAPIAccountCashAdjustQryReq
{
	TAPIUINT32					SerialID;
	TAPISTR_20					AccountNo;
	TAPISTR_20					AccountAttributeNo;				///< ͻ
	TAPIDATE					BeginDate;						///< 
	TAPIDATE					EndDate;						///< 
};

//! ͻʽѯӦṹ(ר)
struct TapAPIAccountCashAdjustQryRsp
{
	TAPIDATE					Date;							///< 
	TAPISTR_20					AccountNo;						///< ͻʽ˺

	TAPICashAdjustTypeType		CashAdjustType;					///< ʽ
	TAPISTR_10					CurrencyGroupNo;				///< 
	TAPISTR_10					CurrencyNo;						///< ֺ
	TAPIREAL64					CashAdjustValue;				///< ʽ
	TAPISTR_100					CashAdjustRemark;				///< ʽע

	TAPIDATETIME				OperateTime;					///< ʱ
	TAPISTR_20					OperatorNo;						///< Ա

	TAPISTR_10					AccountBank;					///< ͻ
	TAPISTR_20					BankAccount;					///< ͻ˺
	TAPIBankAccountLWFlagType	AccountLWFlag;					///< ͻұʶ
	TAPISTR_10					CompanyBank;					///< ˾
	TAPISTR_20					InternalBankAccount;			///< ˾˻
	TAPIBankAccountLWFlagType	CompanyLWFlag;					///< ˾ұʶ
};

//! ͻ˵ѯṹ(ר)
struct TapAPIBillQryReq
{
	TAPISTR_20					UserNo;
	TAPIBillTypeType			BillType;
	TAPIDATE					BillDate;
	TAPIBillFileTypeType		BillFileType;
};

//! ͻ˵ѯӦṹ(ר)
struct TapAPIBillQryRsp
{
	TapAPIBillQryReq			Reqdata;
	TAPIINT32					BillLen;
	TAPICHAR					BillText[1];	///< 䳤˵ݣBillLenָ
};
	
//! ʷίвѯṹ(ר)
struct TapAPIHisOrderQryReq
{
	TAPISTR_20					AccountNo;							///< ͻʽ˺
	TAPISTR_20					AccountAttributeNo;					///< ͻԺ
	TAPIDATE					BeginDate;							///< ʼʱ ()
	TAPIDATE					EndDate;							///< ʱ ()
};

//! ʷίвѯӦṹ(ר)
struct TapAPIHisOrderQryRsp
{
	TAPIDATE					Date;								///< 
	TAPISTR_20					AccountNo;							///< ͻʽ˺

	TAPISTR_10					ExchangeNo;							///< 
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ
	TAPISTR_10					StrikePrice;						///< ִм۸
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ſ
	TAPISTR_10					ContractNo2;						///< Լ2
	TAPISTR_10					StrikePrice2;						///< ִм۸2
	TAPICallOrPutFlagType		CallOrPutFlag2;						///< ſ2

	TAPIOrderTypeType			OrderType;							///< ί
	TAPIOrderSourceType			OrderSource;						///< ίԴ
	TAPITimeInForceType			TimeInForce;						///< ίЧ
	TAPIDATETIME				ExpireTime;							///< Ч(GTDʹ)
	TAPIYNFLAG					IsRiskOrder;						///< Ƿձ
	TAPISideType				OrderSide;							///< 
	TAPIPositionEffectType		PositionEffect;						///< ƽ־
	TAPIPositionEffectType		PositionEffect2;					///< ƽ־2
	TAPISTR_50					InquiryNo;							///< ѯۺ
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ
	TAPIREAL64					OrderPrice;							///< ίм۸
	TAPIREAL64					OrderPrice2;						///< ίм۸2Ӧʹ
	TAPIREAL64					StopPrice;							///< ۸
	TAPIUINT32					OrderQty;							///< ί
	TAPIUINT32					OrderMinQty;						///< Сɽ
	TAPIUINT32					OrderCanceledQty;					///< 

	TAPIINT32					RefInt;								///< Ͳοֵ
	TAPIREAL64					RefDouble;							///<ο͡
	TAPISTR_50					RefString;							///< ַοֵ

	TAPICHAR					ServerFlag;							///< ʶ
	TAPISTR_20					OrderNo;                                            ///< ίб
	TAPIUINT32					OrderStreamID;						///< ίˮ

	TAPISTR_10					UpperNo;							///< ֺ
	TAPISTR_10					UpperChannelNo;						///< ͨ
	TAPISTR_20					OrderLocalNo;						///< غ
	TAPIUINT32					UpperStreamID;						///< 

	TAPISTR_50					OrderSystemNo;						///< ϵͳ
	TAPISTR_50					OrderExchangeSystemNo;				///< ϵͳ
	TAPISTR_50					OrderParentSystemNo;				///< ϵͳ 

	TAPISTR_20					OrderInsertUserNo;					///< µ
	TAPIDATETIME				OrderInsertTime;					///< µʱ
	TAPISTR_20					OrderCommandUserNo;					///< ָ´
	TAPISTR_20					OrderUpdateUserNo;					///< ίи
	TAPIDATETIME				OrderUpdateTime;					///< ίиʱ

	TAPIOrderStateType			OrderState;							///< ί״̬

	TAPIREAL64					OrderMatchPrice;					///< ɽ
	TAPIREAL64					OrderMatchPrice2;					///< ɽ2
	TAPIUINT32					OrderMatchQty;						///< ɽ
	TAPIUINT32					OrderMatchQty2;						///< ɽ2

	TAPIUINT32					ErrorCode;							///< һβϢ
	TAPISTR_50					ErrorText;							///< Ϣ

	TAPIYNFLAG					IsBackInput;						///< ǷΪ¼ίе
	TAPIYNFLAG					IsDeleted;							///< ίгɽɾ
	TAPIYNFLAG					IsAddOne;							///< ǷΪT+1
	TAPIYNFLAG					AddOneIsValid;						///< ǷT+1Ч

	TAPIUINT32					MinClipSize;						///< ɽС
	TAPIUINT32					MaxClipSize;						///< ɽ
	TAPISTR_50					LicenseNo;							///< Ȩ

	TAPITacticsTypeType			TacticsType;						///< Ե	
	TAPITriggerConditionType	TriggerCondition;					///< 
	TAPITriggerPriceTypeType	TriggerPriceType;					///< ۸
};

//! ʷɽѯṹ(ר)
struct TapAPIHisFillQryReq
{
	TAPISTR_20					AccountNo;							///< ͻʽ˺
	TAPISTR_20					AccountAttributeNo;					///< ͻԺ
	TAPIDATE					BeginDate;							///< ʼڣ
	TAPIDATE					EndDate;							///< ڣ
	TAPICHAR					CountType;							///< ͳ
};

//! ʷɽѯӦṹ(ר)
//! key1=SerialID
//! key2=ExchangeNo+MatchCmbNo+MatchNo+MatchSide
struct TapAPIHisFillQryRsp
{
	TAPIDATE					SettleDate;							///< 
	TAPIDATE					TradeDate;							///<
	TAPISTR_20					AccountNo;							///< ͻʽ˺

	TAPISTR_10					ExchangeNo;							///< г߽
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֺ
	TAPISTR_10					ContractNo;							///< Լ
	TAPISTR_10					StrikePrice;						///< ִм
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ǿ־

	TAPIMatchSourceType			MatchSource;						///< ɽԴ	
	TAPISideType				MatchSide;							///< 
	TAPIPositionEffectType		PositionEffect;						///< ƽ־
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ
	TAPIREAL64					MatchPrice;							///< ɽ
	TAPIUINT32					MatchQty;							///< ɽ

	TAPISTR_20					OrderNo;							///< ίк
	TAPISTR_20					MatchNo;							///< ɽ
	TAPIUINT32					MatchStreamID;						///< ɽˮ

	TAPISTR_10					UpperNo;							///< ֺ
	TAPISTR_20					MatchCmbNo;							///< Ϻ
	TAPISTR_70					ExchangeMatchNo;					///< ɽ(ɽ)
	TAPIUINT32					MatchUpperStreamID;					///< ˮ

	TAPISTR_10					CommodityCurrencyGroup;
	TAPISTR_10					CommodityCurrency;					///< Ʒֱ		

	TAPIREAL64					Turnover;							///< ɽ
	TAPIREAL64					PremiumIncome;						///< Ȩ
	TAPIREAL64					PremiumPay;							///< Ȩ֧

	TAPIREAL64					AccountFee;							///< ͻ
	TAPISTR_10					AccountFeeCurrencyGroup;
	TAPISTR_10					AccountFeeCurrency;					///< ͻѱ
	TAPIYNFLAG					IsManualFee;						///< ˹ͻѱ
	TAPIREAL64					AccountOtherFee;					///< ͻ

	TAPIREAL64					UpperFee;							///< 
	TAPISTR_10					UpperFeeCurrencyGroup;
	TAPISTR_10					UpperFeeCurrency;					///< ѱ
	TAPIYNFLAG					IsUpperManualFee;					///< ˹ѱ
	TAPIREAL64					UpperOtherFee;						///< 

	TAPIDATETIME				MatchDateTime;						///< ɽʱ
	TAPIDATETIME				UpperMatchDateTime;					///< ֳɽʱ

	TAPIREAL64					CloseProfit;						///< ƽӯ
	TAPIREAL64					ClosePrice;							///< ָƽּ۸	

	TAPIUINT32					CloseQty;							///< ƽ

	TAPISTR_10					SettleGroupNo;						///<
	TAPISTR_20					OperatorNo;							///< Ա
	TAPIDATETIME				OperateTime;						///< ʱ
};

//! ʷί̲ѯṹ(ר)
struct TapAPIHisOrderProcessQryReq
{
	TAPIDATE					Date;
	TAPISTR_20					OrderNo;
};

//! ʷί̲ѯӦݽṹ(ר)
typedef TapAPIHisOrderQryRsp		TapAPIHisOrderProcessQryRsp;

//! ʷֲֲѯṹ(ר)
struct TapAPIHisPositionQryReq
{
	TAPISTR_20					AccountNo;						///< ͻʽ˺
	TAPISTR_20					AccountAttributeNo;				///< ͻԺ
	TAPIDATE					Date;							///< 
	TAPICHAR					CountType;						///< ͳ
};

//! ʷֲֲѯӦṹ(ר)
//! key1=SerialID
//! key2=++ű+ֱֲ+
struct TapAPIHisPositionQryRsp
{
	TAPIDATE					SettleDate;							///< 
	TAPIDATE					OpenDate;							///< 

	TAPISTR_20					AccountNo;							///< ͻʽ˺

	TAPISTR_10					ExchangeNo;							///< г߽
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ
	TAPISTR_10					StrikePrice;						///< ִм
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ǿ־

	TAPISideType				MatchSide;							///< 
	TAPIHedgeFlagType			HedgeFlag;							///< Ͷֵ
	TAPIREAL64					PositionPrice;						///< ֲּ۸
	TAPIUINT32					PositionQty;						///< ֲ

	TAPISTR_20					OrderNo;							///< 
	TAPISTR_70					PositionNo;							///< ֱֲ

	TAPISTR_10					UpperNo;							///< ֺ	

	TAPISTR_10					CurrencyGroup;						///< Ʒֱ
	TAPISTR_10					Currency;							///< Ʒֱ

	TAPIREAL64					PreSettlePrice;						///< ս۸
	TAPIREAL64					SettlePrice;						///< ۸
	TAPIREAL64					PositionDProfit;					///< ֲӯ()
	TAPIREAL64					LMEPositionProfit;					///< LMEֲӯ
	TAPIREAL64					OptionMarketValue;					///< Ȩֵ

	TAPIREAL64					AccountInitialMargin;				///< ͻʼ֤
	TAPIREAL64					AccountMaintenanceMargin;			///< ͻάֱ֤
	TAPIREAL64					UpperInitialMargin;					///< ֳʼ֤
	TAPIREAL64					UpperMaintenanceMargin;				///< άֱ֤

	TAPISTR_10					SettleGroupNo;						///< 
};

//! ѯṹ(ר)
struct TapAPIHisDeliveryQryReq
{
	TAPISTR_20					AccountNo;							///< ͻʽ˺
	TAPISTR_20					AccountAttributeNo;					///< ͻԺ
	TAPIDATE					BeginDate;							///< ʼڣ
	TAPIDATE					EndDate;							///< ڣ
	TAPICHAR					CountType;							///< ͳ
};

//! ѯӦݽṹ(ר)
//! key1=SerialID
struct TapAPIHisDeliveryQryRsp
{
	TAPIDATE					DeliveryDate;						///< 
	TAPIDATE					OpenDate;							///< 
	TAPISTR_20					AccountNo;							///< ͻʽ˺

	TAPISTR_10					ExchangeNo;							///< гŻ
	TAPICommodityType			CommodityType;						///< Ʒ
	TAPISTR_10					CommodityNo;						///< Ʒֱ
	TAPISTR_10					ContractNo;							///< Լ
	TAPISTR_10					StrikePrice;						///< ִм
	TAPICallOrPutFlagType		CallOrPutFlag;						///< ǿ־

	TAPIMatchSourceType			MatchSource;						///< ɽԴ
	TAPISideType				OpenSide;							///< ַ
	TAPIREAL64					OpenPrice;							///< ּ۸
	TAPIREAL64					DeliveryPrice;						///< ۸
	TAPIUINT32					DeliveryQty;						///< 
	TAPIUINT32					FrozenQty;							///< 

	TAPISTR_20					OpenNo;								///< ֳɽ
	TAPISTR_10					UpperNo;							///< ֱ

	TAPISTR_10					CommodityCurrencyGroupy;			///< Ʒֱ
	TAPISTR_10					CommodityCurrency;					///< Ʒֱ
	TAPIREAL64					PreSettlePrice;						///< ս
	TAPIREAL64					DeliveryProfit;						///< ӯ

	TAPIREAL64					AccountFrozenInitialMargin;			///< ͻʼᱣ֤
	TAPIREAL64					AccountFrozenMaintenanceMargin;		///< ͻάֶᱣ֤
	TAPIREAL64					UpperFrozenInitialMargin;			///< ֳʼᱣ֤
	TAPIREAL64					UpperFrozenMaintenanceMargin;		///< άֶᱣ֤

	TAPISTR_10					AccountFeeCurrencyGroup;
	TAPISTR_10					AccountFeeCurrency;					///< ͻѱ
	TAPIREAL64					AccountDeliveryFee;					///< ͻ 
	TAPISTR_10					UpperFeeCurrencyGroup;
	TAPISTR_10					UpperFeeCurrency;					///< ѱ
	TAPIREAL64					UpperDeliveryFee;					///< ֽ

	TAPIDeliveryModeType		DeliveryMode;						///< Ȩʽ
	TAPISTR_20					OperatorNo;							///< Ա
	TAPIDATETIME				OperateTime;						///< ʱ
	TAPISTR_20					SettleGourpNo;						///< 
};

//! ͻ˻Ѽѯṹרã
struct TapAPIAccountFeeRentQryReq
{
	TAPISTR_20						AccountNo;
};
//! ͻ˻ѼѯӦṹרã
struct TapAPIAccountFeeRentQryRsp
{
	TAPISTR_20						AccountNo;
	TAPISTR_10						ExchangeNo;
	TAPICommodityType				CommodityType;
	TAPISTR_10						CommodityNo;
	TAPIMatchSourceType				MatchSource;
	TAPICalculateModeType			CalculateMode;
	TAPISTR_10						CurrencyGroupNo;
	TAPISTR_10						CurrencyNo;			
	TAPIREAL64						OpenCloseFee;
	TAPIREAL64						CloseTodayFee;
};

//! ͻ˻֤ѯṹרã
struct TapAPIAccountMarginRentQryReq
{
	TAPISTR_20						AccountNo;
	TAPISTR_10						ExchangeNo;
	TAPICommodityType				CommodityType;
	TAPISTR_10						CommodityNo;
	//TAPISTR_10					ContractNo;//ʱȲ⿪š
};

//! ͻ˻֤ѯӦ𣨱רã
struct TapAPIAccountMarginRentQryRsp
{
	TAPISTR_20						AccountNo;
	TAPISTR_10						ExchangeNo;
	TAPICommodityType				CommodityType;
	TAPISTR_10						CommodityNo;
	TAPISTR_10						ContractNo;
	TAPISTR_10						StrikePrice;
	TAPICallOrPutFlagType			CallOrPutFlag;
	TAPICalculateModeType			CalculateMode;
	TAPISTR_10						CurrencyGroupNo;
	TAPISTR_10						CurrencyNo;
	TAPIREAL64						InitialMargin;
	TAPIREAL64						MaintenanceMargin;
	TAPIREAL64						SellInitialMargin;
	TAPIREAL64						SellMaintenanceMargin;
	TAPIREAL64						LockMargin;
};

//! ֤ϢӦṹ
struct TapAPISecondInfo
{
	TAPISendTypeType               SendType;           ///< 
	TAPISTR_40                     SendAccount;        ///< ˺(ֻŻ)
};

//! ֤ȨӦ
struct TapAPIVertificateCode
{
	TAPISecondSerialIDType SecondSerialID;				///< ֤Ȩ
	TAPIINT32              Effective;					///< ֤ȨЧڣ֣
};

//! ¼ûֻ豸ṹ
struct TapAPIMobileDeviceAddReq
{
	TAPISTR_20					UserNo;								///< û
	TAPISTR_30                  AppKey;
	TAPISTR_30                  AppID;
	TAPISTR_30                  MasterSecret;
	TAPISTR_50                  Cid;
	TAPISTR_10                  CompanyNo;
	TAPISTR_20                  CompanyAddressNo;
	TAPIDeviceTypeType          DeviceType;
};

//! ¼ûֻ豸Ӧṹ
typedef TapAPIMobileDeviceAddReq  TapAPIMobileDeviceAddRsp;

//! ־ѯṹ
struct TapAPIManageInfoQryReq
{
	TAPIDATE                BeginDate;		///< ʼڣ
	TAPIDATE				EndDate;		///< ڣ
};

//! ־ѯӦṹ
struct TapAPIManageInfo
{
    TAPIUINT32             MsgID;                              ///< к
	TAPISTR_50             SendFrom;                           ///< (ţʱΪ)
	TAPICHAR               SendManageType;					   ///< 
	TAPISTR_20             AccountNo;						   ///< ͻʽ˺
	TAPISTR_200            SendAccount;                        ///< ˺(ֻŻ)ֻȡŵ绰绰绰ȡ˵

	TAPISTR_200            Title;                              ///< 
	TAPISTR_500            Content;                            ///< 
	TAPISTR_500            Attachment;                         ///< 
	TAPICHAR               SendStatus;                         ///< ״̬
	TAPISTR_100            Remark;                             ///< ע
	TAPISTR_100            GUID;                               ///< GUID

	TAPISTR_20             OperatorNo;						   ///< Ա
	TAPIDATETIME           OperateTime;						   ///< ʱ
};

//! ϵͳѯṹ
struct TapAPISystemParameterQryReq
{

};

//! ϵͳѯӦṹ
struct TapAPISystemParameterInfo
{
	TAPISTR_10						ItemNo;								///< Ŀ
	TAPISTR_10					    ExchangeNo;							///< 
	TAPISTR_10				    	CommodityNo;						///< Ʒֱ
	TAPICommodityType				CommodityType;						///< Ʒ
	TAPIINT32				    	ItemValue;							///< Ŀֵ
	TAPISTR_20				    	ItemValueStr;						///< Ŀֵֵַ	
	TAPIREAL64			        	ItemValueDouble;					///< Ŀֵֵ
};

//! ǰõַϢѯṹ
struct TapAPITradeCenterFrontAddressQryReq
{
	TAPISTR_50					FrontAddress;						///< ǰõַ ղ
	TAPISTR_10					FrontPort;							///< ǰö˿ ղ
	TAPICHAR                    TradeCenter;                        ///<  ղ
	TAPICHAR                    IsSSL;                              ///< Ƿܶ˿
};

//! ǰõַϢѯӦṹ
struct TapAPITradeCenterFrontAddressInfo
{
	TAPISTR_50					FrontName;							///< ǰ
	TAPISTR_50					FrontAddress;						///< ǰõַ
	TAPISTR_10					FrontPort;							///< ǰö˿
	TAPICHAR                    TradeCenter;                        ///< 	
	TAPICHAR					IsEnable;							///< Ƿ
	TAPICHAR                    IsSSL;                              ///< Ƿܶ˿
};

#pragma pack(pop)

}

#endif //ES_TRADE_API_STRUCT_H