//============================================================================
/* ʢͳһAPIӿ
 * ļEsTradeAPI ʹõĽӿں͹
 * 汾Ϣ:2018-05-21  ļ
 */
//=============================================================================
#ifndef ES_TRADE_API_H
#define ES_TRADE_API_H

#include "EsTradeAPIStruct.h"

#if defined WIN32 || defined _WIN64
#define ES_CDECL __cdecl
#define ES_DLLEXPORT __declspec(dllexport)
#else
#define ES_CDECL
#define ES_DLLEXPORT
#endif

//EsTradeAPI.h
//ļEsTradeAPIṩߵĶӿڡͻصӿڡ
namespace EsTradeAPI
{
	
//EsTradeAPI Ļص֪ͨӿ
class IEsTradeAPINotify
{
public:
	/**
	* @brief ĳһ¼ûӳɹص֪ͨ
	* @param[in] UserNo ¼ûUserNo
	* @ingroup G_T_Login
	*/
	virtual void ES_CDECL OnConnect(const TAPISTR_20 UserNo) = 0;
	/**
	* @brief	ϵͳ¼̻ص
	* @details	˺ΪLogin()¼ĻصLogin()ɹ·ӣȻAPI͵¼֤Ϣ
	*			¼ڼݷ͵¼ĻϢݵ˻صС
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nErrorCode ش,0ʾɹ
	* @param[in] pLoginRspInfo ½ӦϢnErrorCode!=0loginRspInfo=NULL
	* @attention	ûصسɹ˵û¼ɹǲǰ¼û׼ϡ
	* @ingroup G_T_Login
	*/
	virtual void ES_CDECL OnRspLogin(const TAPISTR_20 UserNo, TAPIINT32 nErrorCode, const TapAPITradeLoginRspInfo *pLoginRspInfo) = 0;
	/**
	* @brief	֤ϵʽ֪ͨ(ר)
	* @details	¼ɺҪ֤յϵʽ֪ͨѡ֪ͨϢһϵʽߵ绰
	*			Ͷ֤Ȩ루RequestVertificateCode
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nErrorCode ش,0ʾɹ˻ûа󶨶֤ϵʽ򷵻10055
	* @param[in] isLast ʶǷһϵϢ
	* @param[in] pInfo ֤ʽϢerrorCode!=0ContactInfoΪա
	* @attention	ûصسɹ˵Ҫ֤ҪѡһϵʽȻRequestVertificateCode
	* @ingroup G_T_Login
	*/
	virtual void ES_CDECL OnRtnContactInfo(const TAPISTR_20 UserNo, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPISecondInfo* pInfo) = 0;
	/**
	* @brief	Ͷ֤Ӧ(ר)
	* @details	ȡ֤Ȩ룬̨ʼ߶ţӦ𣬰Լ֤Чڡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nSessionID ֤ỰID
	* @param[in] nErrorCode ûаϵش.
	* @param[in] isLast ʶǷһϵϢ
	* @param[in] pInfo ֤ЧڣԷӷأڶ֤Чڣظö֤룬ǲ֤롣
	* @attention ûصسɹȻSetVertificateCode
	* @ingroup G_T_Login
	*/
	virtual void ES_CDECL OnRspRequestVertificateCode(const TAPISTR_20 UserNo, TAPIUINT32 nSessionID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIVertificateCode *pInfo) = 0;
	/**
	* @brief ҪϢʾ
	* @details APIڲشʱʾûϢ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] ErrorMsg ʾϢ
	* @attention úص˵APIʱش
	* @ingroup G_T_TradeSystem
	*/
	virtual void ES_CDECL OnRtnErrorMsg(const TAPISTR_20 UserNo, const TAPISTR_500 ErrorMsg) = 0;
	/**
	* @brief	֪ͨûAPI׼
	* @details	ֻûصյ˾֪ͨʱܽжӦ¼ûĸֲ˻صĳ¼ûܷı־
	* @param[in] UserNo ¼ûUserNo
	* @attention ſԽк
	* @ingroup G_T_Login
	*/
	virtual void ES_CDECL OnAPIReady(const TAPISTR_20 UserNo) = 0;
	/**
	* @brief APIͷʧȥӵĻص
	* @details APIʹù߱ʧȥӺ󶼻ᴥ˻ص֪ͨûѾϿ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nReasonCode Ͽԭ롣
	* @ingroup G_T_Disconnect
	*/
	virtual void ES_CDECL OnDisconnect(const TAPISTR_20 UserNo, TAPIINT32 nReasonCode) = 0;
	/**
	* @brief ֪ͨûύû¼Ϣ(ר)
	* @param[in] UserNo ָϢӦUserNo 
	* @param[in] nSessionID ύû¼ϢID,SubmitUserLoginInfoصIDӦ
	* @param[in] pRspInfo ָ򷵻صϢṹ塣
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_UserInfo
	*/
	virtual void ES_CDECL OnRspSubmitUserLoginInfo(const TAPISTR_20 UserNo, TAPIUINT32 nSessionID, const TapAPISubmitUserLoginInfoRsp *pRspInfo) = 0;
	/**
	* @brief û޸Ӧ(ǡר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nSessionID ޸ID,ChangePasswordIDӦ
	* @param[in] nErrorCode ش룬0ʾɹ
	* @ingroup G_T_UserInfo
	*/
	virtual void ES_CDECL OnRspChangePassword(const TAPISTR_20 UserNo, TAPIUINT32 nSessionID, TAPIINT32 nErrorCode) = 0;
	/**
	* @brief ûԤϢ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nSessionID ûԤϢID
	* @param[in] nErrorCode ش룬0ʾɹ
	* @param[in] info ָ򷵻صϢṹ塣nErrorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @note ýӿδʵ
	* @ingroup G_T_UserInfo
	*/
	virtual void ES_CDECL OnRspSetReservedInfo(const TAPISTR_20 UserNo, TAPIUINT32 nSessionID, TAPIINT32 nErrorCode, const TAPISTR_50 info) = 0;
	/**
	* @brief	ԼϢ(ǡר)
	* @details	ûµĺԼҪڽʱзºԼʱûԼϢ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo	ָ򷵻صϢṹ塣
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_Contract
	*/
	virtual void ES_CDECL OnRtnContract(const TAPISTR_20 UserNo, const TapAPITradeContractInfo *pRtnInfo) = 0;
	/**
	* @brief ûʽ仯֪ͨ
	* @details ûίгɽʽݵı仯Ҫûʵʱ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo ָ򷵻صϢṹ塣
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_FundInfo
	*/
	virtual void ES_CDECL OnRtnFund(const TAPISTR_20 UserNo, const TapAPIFundData *pRtnInfo) = 0;
	/**
	* @brief ίСµĻطµ͹ġ
	* @details յͻµίݺͻᴥίд߼ͬʱûһίӦ˵ȷû󣬷صϢаȫίϢ
	*			ͬʱһʾίеίкšǱطȥίУίӦл᷵ID
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] pRtnInfo ָ򷵻صϢṹ
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void ES_CDECL OnRtnOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIOrderInfo *pRtnInfo) = 0;
	/**
	* @brief زѯίб仯Ϣ(ǡר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 룬nErrorCode=0ʱpRspInfoָ򷵻صίб仯̽ṹ壬ȻΪNULL
	* @param[in] isLast ʾǷһݣ
	* @param[in] pRspInfo صίб仯ָ롣
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void ES_CDECL OnRspQryOrderProcess(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIOrderInfo *pRspInfo) = 0;
	/**
	* @brief ĳɽϢ
	* @details ûίгɽûͳɽϢ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo ָ򷵻صϢṹ塣
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void ES_CDECL OnRtnFill(const TAPISTR_20 UserNo, const TapAPIFillInfo *pRtnInfo) = 0;
	/**
	* @brief ֱֲ仯֪ͨ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo ָ򷵻صϢṹ塣
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void ES_CDECL OnRtnPosition(const TAPISTR_20 UserNo, const TapAPIPositionInfo *pRtnInfo) = 0;
	/**
	* @brief ƽݱ仯(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo ָ򷵻صϢṹ塣
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void ES_CDECL OnRtnClose(const TAPISTR_20 UserNo, const TapAPICloseInfo *pRtnInfo) = 0;
	/**
	* @brief ֲӯ֪ͨ(ǡר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo ָ򷵻صϢṹ塣
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void ES_CDECL OnRtnPositionProfit(const TAPISTR_20 UserNo, const TapAPIPositionProfitNotice *pRtnInfo) = 0;
	/**
	* @brief ѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast ʾǷһݣ
	* @param[in] pRspInfo ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpRspInfoΪա
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_DeepQuote
	*/
	virtual void ES_CDECL OnRspQryDeepQuote(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIDeepQuoteQryRsp *pRspInfo) = 0;
	/**
	* @brief ʱ״̬Ϣ֪ͨ	(ǣֻר)
	* @param[out] UserNo ָϢӦUserNo
	* @param[out] pRtnInfo ָ򷵻صϢṹ塣
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void ES_CDECL OnRtnExchangeStateInfo(const TAPISTR_20 UserNo, const TapAPIExchangeStateInfoNotice *pRtnInfo) = 0;
	/**
	* @brief ѯ֪ͨ(ǡר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo ָ򷵻صϢṹ塣
	* @attention Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void ES_CDECL OnRtnReqQuoteNotice(const TAPISTR_20 UserNo, const TapAPIReqQuoteNotice *pRtnInfo) = 0;
	/**
	* @brief ͻշӦ(ר)
	* @details ֤㷽ʽ*ÿֳ**۸
	*          ֤𶨶㷽ʽ*
	*          ѾԷʽ㷽ʽ*+*ÿֳ*۸*
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pRspInfo	ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpRspInfoΪա
	* @attention  Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_AccountRentInfo
	*/
	virtual void ES_CDECL OnRspAccountRentInfo(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIAccountRentInfo *pRspInfo) = 0;
	/**
	* @brief	ϢѯӦ(ǡר)
	* @details	ûԲѯصĽϢ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pRspInfo	ָ򷵻صϢṹ塣
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void ES_CDECL OnRspTradeMessage(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPITradeMessage *pRspInfo) = 0;
    /**
	* @brief	Ϣ֪ͨ(ǡר)
	* @details	ûڽ׹пΪʽ𡢳ֲ֡ƽֵ״̬䶯ʹ˻ĳЩΣ״̬ĳЩҪϢҪû֪ͨ
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] pRtnInfo	ָ򷵻صϢṹ塣
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void ES_CDECL OnRtnTradeMessage(const TAPISTR_20 UserNo, const TapAPITradeMessage *pRtnInfo) = 0;
	/**
	* @brief ʷίвѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_HisInfo
	*/
	virtual void ES_CDECL OnRspQryHisOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIHisOrderQryRsp *pInfo) = 0;
	/**
	* @brief ʷί̲ѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_HisInfo
	*/
	virtual void ES_CDECL OnRspQryHisOrderProcess(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIHisOrderProcessQryRsp *pInfo) = 0;
	/**
	* @brief ʷɽѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_HisInfo
	*/
	virtual void ES_CDECL OnRspQryHisFill(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIHisFillQryRsp *pInfo) = 0;
	/**
	* @brief ʷֲֲѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_HisInfo
	*/
	virtual void ES_CDECL OnRspQryHisPosition(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIHisPositionQryRsp *pInfo) = 0;
	/**
	* @brief ʷѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_HisInfo
	*/
	virtual void ES_CDECL OnRspQryHisDelivery(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIHisDeliveryQryRsp *pInfo) = 0;
	/**
	* @brief ʽѯӦ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_FundInfo
	*/
	virtual void ES_CDECL OnRspQryAccountCashAdjust(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIAccountCashAdjustQryRsp *pInfo) = 0;
	/**
	* @brief ѯû˵Ӧ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_Bill
	*/
	virtual void ES_CDECL OnRspQryBill(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIBillQryRsp *pInfo) = 0;
	/**
	* @brief ѯûѲ(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_AccountRentInfo
	*/
	virtual void ES_CDECL OnRspAccountFeeRent(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIAccountFeeRentQryRsp *pInfo) = 0;
	/**
	* @brief ѯû֤(ר)
	* @param[in] UserNo ָϢӦUserNo
	* @param[in] nRequestID ĻỰID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @ingroup G_T_AccountRentInfo
	*/
	virtual void ES_CDECL OnRspAccountMarginRent(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIAccountMarginRentQryRsp *pInfo) = 0;
	/**
	* @brief ¼ûֻ豸Ӧ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual void ES_CDECL OnRspAddMobileDevice(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIMobileDeviceAddRsp *pInfo) = 0;
	/**
	* @brief ־ѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual void ES_CDECL OnRspQryManageInfoForEStar(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPIManageInfo *pInfo) = 0;
	/**
	* @brief ϵͳѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual void ES_CDECL OnRspQrySystemParameter(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPISystemParameterInfo *pInfo) = 0;
	/**
	* @brief ǰõַϢѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] nErrorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] pInfo		ָ򷵻صϢṹ塣nErrorCodeΪ0ʱpInfoΪա
	* @attention Ҫ޸ĺɾpInfoָʾݣýЧ
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual void ES_CDECL OnRspQryTradeCenterFrontAddress(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, TAPIINT32 nErrorCode, TAPIYNFLAG isLast, const TapAPITradeCenterFrontAddressInfo *pInfo) = 0;
	/**
	* @brief ƷϢ֪ͨ(ר)
	* @param[out] UserNo ָϢӦUserNo
	* @param[out] pInfo	ָ򷵻صϢṹ塣
	* @attention  Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_Commodity
	*/
	virtual void ES_CDECL OnRtnCommodityInfo(const TAPISTR_20 UserNo, const TapAPICommodityInfo *pInfo) = 0;
	/**
	* @brief Ϣ֪ͨ(ר)
	* @param[out] UserNo ָϢӦUserNo
	* @param[out] pInfo	ָ򷵻صϢṹ塣
	* @attention  Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void ES_CDECL OnRtnCurrencyInfo(const TAPISTR_20 UserNo, const TapAPICurrencyInfo *pInfo) = 0;
};

//EsTradeAPI ⹦ܽӿڡûԵõĹܺ
class IEsTradeAPI
{
public:
	/**
	* @brief	APIĻصӿڶ
	* @details	ϵͳAPI֪ͨͨõĻص֪ͨʹߡ
	*			IEsTradeAPINotifyAPIĻصӿڣûҪ̳ʵִ˽ӿûҪĹܡ
	*           ûûûصӿڣAPIûκõϢ
	* @param[in] pApiNotify ʵIEsTradeAPINotifyӿڵĶָ롣
	* @operationtype ͬ
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 ES_CDECL SetAPINotify(IEsTradeAPINotify *pApiNotify) = 0;
	/**
	* @brief	APIĿ¼
	* @details	úͬʱpathĿ¼´գʽEsTradeAPIYYYYMMDD.log)ļ
	*			ļбΪAPIյҪݺAPIʹúʹ־
	* @param[in] pPath Ŀ¼ãĿ¼WindowΪ\\ߡ/, LinuxΪ/
	* @retval 0 óɹ0 
	* @operationtype ͬ
	* @ingroup G_T_LogConfig
	*/
	virtual TAPIINT32 ES_CDECL SetEsTradeAPIDataPath(const TAPICHAR *pPath) = 0;
	/**
	* @brief	API־
	* @details	趨־ֻеʵ־˴趨ļͬʱŻὫ־дSetEsTradeAPIDataPath()򿪵־ļ
	*			Ĭ־ΪAPILOGLEVEL_ERROR
	* @param[in] LogLevel ־
	*			APILOGLEVEL_ERROR	ֻ¼Error־(APIΪĴ־)
	*			APILOGLEVEL_NORMAL	¼Error־ͨ־
	*			APILOGLEVEL_DEBUG	¼Error־Debug־
	* @retval 0 趨ɹ0 
	* @operationtype ͬ
	* @ingroup G_T_LogConfig
	* @remark APIһEsTradeAPIYYYYMMDD.log־ļм¼һЩAPIΪҪ¼־
	*/
	virtual TAPIINT32 ES_CDECL SetEsTradeAPILogLevel(TAPILOGLEVEL LogLevel) = 0;
	/**
	* @brief		õ¼ûϢAPIֶ֧½Զεøýӿڡ
	* @param[in]	pUserInfo ¼ûϢ
	* @retval		0 óɹ0 
	* @operationtype ͬ
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 ES_CDECL SetUserInfo(const TapAPITradeUserInfo *pUserInfo) = 0;
	/**
	* @brief	ĳһûʼAPIڲӷ񣬽·¼֤ά·Ϣ
	*			·ϿAPIڲԶɹٴԶ¼֤
	*			ֵ¼ʧܣAPIڲֹͣظ¼󣩣ʱҪAPIʹȵStopUserȻٴʹȷĵ¼ϢStartUser
	* @details	ʹúǰûҪɵ¼ûϢSetUserInfo()ҴEsTdAPITradeLoginAuth͵ûϢ
	*			Ҫúûصӿڡ
	*			¼нӵķϢͨصOnConnectظû
	*			ӽû֤ϢͨصOnLogin()ظû
	*			¼ɹAPIԶAPIĳʼAPIݣѯԺͨصOnAPIReady()
	*			ָʾûAPIʼɣԽкĲˡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pLoginAuth ¼֤Ϣṹָ롣¼Ҫ֤Ϣ
	* @retval 0 ¼ɹAPIʼ׼̨;0 
	* @operationtype 첽
	* @note EsTdAPITradeLoginAuthеNoticeIgnoreFlagڱǷض֪ͨص
	*       磺ҪOnRtnFundOnRtnPositionProfit,ô趨
	*       NoticeIgnoreFlag = TAPI_NOTICE_IGNORE_FUND | TAPI_NOTICE_IGNORE_POSITIONPROFIT;
	* @attention Login()óɹֻǴڷ·ӣֻлصOnLogin()ķָʾûǷɹ¼ˡ
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 ES_CDECL StartUser(const TAPISTR_20 UserNo, const TapAPITradeLoginAuth *pLoginAuth) = 0;
	/**
	* @brief ֹͣĳһûAPIû˳Ͽӣֹͣ
	* @details úAPIǳϿӡ
	* @param[in] UserNo ¼ûUserNo
	* @operationtype ͬ
	* @ingroup G_T_Disconnect
	*/
	virtual TAPIINT32 ES_CDECL StopUser(const TAPISTR_20 UserNo) = 0;
	/**
	* @brief	Ͷ֤֤(ר)
	* @details	ݻصOnRtnContactInfoеϵʽѡһ֤
	*			յȷӦͨSetVertificateCode ö֤Ȩɵ½̡
	* @param[in]	UserNo ¼ûUserNo
	* @param[in] nSessionID ĻỰID
	* @param[in]  pReqInfo Ҫն֤ߵ绰
	* @attention úҪڵ½Ӧ󷵻10003APIصͻ֤ϵʽûѡһϵʽߵ绰֤ͨö֤Ȩɵ½
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 ES_CDECL RequestVertificateCode(const TAPISTR_20 UserNo, TAPIUINT32 nSessionID, const TapAPISecondInfo *pReqInfo) = 0;
	/**
	* @brief	ö֤Ϣ(ר)
	* @details	¼ɺϵͳҪж֤룬¼ʾҪж֤
	*			ʱøú֤ɵ¼
	*			¼ɺٵô˺ԭĵ¼ʧҲܵô˺᷵ضӦĴϢ
	*			ô˽ӿں󣬻᷵ص¼Ӧɹıǣɹʾ¼ɣԵȴOnAPIReady APIɻص
	*			ʱصɺAPIϿӣҪٴνе¼
	*			֤ٴεô˺ȷ֤֤
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nSessionID ĻỰID
	* @param[in] VertificateCode ֤롣
	* @retval 0 ֤ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 ES_CDECL SetVertificateCode(const TAPISTR_20 UserNo, TAPIUINT32 nSessionID, TAPISTR_10 VertificateCode) = 0;
	/**
	* @brief мûύû¼Ϣ(ר)
	* @details ¼ɹֻмûʹøú
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ˴ύû¼ϢID 
	* @param[in] pUserLoginInfo û¼Ϣ
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_UserInfo
	*/
	virtual TAPIINT32 ES_CDECL SubmitUserLoginInfo(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPISubmitUserLoginInfo* pUserLoginInfo) = 0;
	/**
	* @brief ޸롣(ǡ)
	* @details ɹû뽫ónewPassword
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ˴޸ID
	* @param[in] pReqInfo ޸Ľṹָ
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_UserInfo
	*/
	virtual TAPIINT32 ES_CDECL ChangePassword(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIChangePasswordReq *pReqInfo) = 0;
	/**
	* @brief ȡ¼ûǷĳȨޡ(ǡ)
	* @details ûȨû¼ʱѾݸAPIԴ˺ִеǱصĲѯ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRightID ȨID
	* @retval 0 Ȩޣ 0 Ȩ
	* @operationtype ͬ
	* @ingroup G_T_UserRight
	*/
	virtual TAPIINT32 ES_CDECL HaveCertainRight(const TAPISTR_20 UserNo, TAPIRightIDType nRightID) = 0;
	/**
	* @brief ûԤϢ
	* @details ûһΪ50ڵַϢ´ε¼ԵõϢҪûȷԼ˺ţҪзα
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] info ԤϢַָ
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @note ýӿδʵ
	* @ingroup G_T_UserInfo
	*/
	virtual TAPIINT32 ES_CDECL SetReservedInfo(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TAPISTR_50 info) = 0;
	/**
	* @brief ȡûʽ˺šSeqIDʼѯÿ෵nOutLenûнҪ´μӲѯһݵSeqID+1ѯ(ǡ)
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡʽ˺Ϣ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_AccountInfo
	*/
	virtual TAPIINT32 ES_CDECL GetAccount(const TAPISTR_20 UserNo, TAPIUINT32 nDataSeqID, TapAPIAccountInfo* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûµнϢSeqIDʼÿ෵nOutLenûнҪ´μӲѯһݵSeqID+1ѯ(ǡ)
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡĽϢ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeSystem
	*/
	virtual TAPIINT32 ES_CDECL GetExchange(const TAPISTR_20 UserNo, TAPIUINT32 nDataSeqID, TapAPIExchangeInfo* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûµƷϢSeqIDʼÿ෵nOutLenûнҪ´μӲѯһݵSeqID+1ѯ(ǡ)
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡƷϢ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_Commodity
	*/
	virtual TAPIINT32 ES_CDECL GetCommodity(const TAPISTR_20 UserNo, TAPIUINT32 nDataSeqID, TapAPICommodityInfo* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûµָƷֵĺԼϢSeqIDʼѯÿ෵nOutLenûнҪ´μӲѯһݵSeqID+1ѯ(ǡ)
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡĺԼϢ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pReqInfo ѯûָƷֵĺԼϢĽṹָ;
	*				    òֶΪѡֶΣ·ѯ
	*					1.ΪգкԼ
	*					2.ЧƷֱΪգýеĺԼ
	*					3.ЧƷֱЧýָƷֵкԼ
	*					4.ЧƷֱЧƷЧƷָƷ͵кԼ
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_Contract
	*/
	virtual TAPIINT32 ES_CDECL GetContract(const TAPISTR_20 UserNo, const TapAPICommodity *pReqInfo, TAPIUINT32 nDataSeqID, TapAPITradeContractInfo* pOutInfo[], TAPIUINT32 nOutLen,  TAPIYNFLAG& isLast) = 0;
	/**
	* @brief µ
	* @details ûµĲûµûʽ𡢳ֲ֡ƽ֡ʽ𡢷رǵȶݵı仯ûµĵɽ󣬻жص֪ͨûչʾݵı仯
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pOrder µί
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 ES_CDECL InsertOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPINewOrder *pOrder) = 0;
	/**
	* @brief 
	* @details ûίûȫɽ֮ǰʣίС
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pOrder ί
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 ES_CDECL CancelOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIOrderCancelReq *pOrder) = 0;
	/**
	* @brief ޸ָ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pOrder ޸ṹ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 ES_CDECL ModifyOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIOrderModifyReq *pOrder) = 0;
	/**
	* @brief (ǡ)
	* @details ıίн¿ʼɽ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pOrder ί
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 ES_CDECL ActivateOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIOrderActivateReq *pOrder) = 0;
	/**
	* @brief ȡָûָʽ˻ĵǰʽϢ
	* @details TapAPIFundReqҪдQryAccount()ȡʽ˺šTapAPIFundReqҪдѯݵʼš
	* @details ˺ѯǱصĲѯ,вɾѾӺ̨ȡʽ˺µʽݡ 
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pReqInfo ѯͻʽĽṹָ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_FundInfo
	*/
	virtual TAPIINT32 ES_CDECL GetFund(const TAPISTR_20 UserNo, const TapAPIFundReq *pReqInfo, TapAPIFundData* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûָĵǰίϢԲѯίУҲԲѯδίС
	* @details ˺ѯǱصĲѯ,ûͺ̨Ͽձݡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pReqInfo ѯͻίĽṹָ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 ES_CDECL GetOrder(const TAPISTR_20 UserNo, const TapAPIOrderQryReq *pReqInfo, TapAPIOrderInfo pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ѯίб仯(ǡ)
	* @details ѯûίеı仯̣ѯίеÿһεı仯
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ί̲ѯϢṹָ롣
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 ES_CDECL QryOrderProcess(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIOrderProcessQryReq *pReqInfo) = 0;
	/**
	* @brief ȡָûָĳɽϢ
	* @details ˺ѯǱصĲѯ,ûͺ̨Ͽձݡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pReqInfo ѯͻίĽṹָ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 ES_CDECL GetFill(const TAPISTR_20 UserNo, const TapAPIFillQryReq *pReqInfo, TapAPIFillInfo pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûָĳֲϢ
	* @details ˺ѯǱصĲѯ,ûͺ̨Ͽձݡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pReqInfo ѯͻίĽṹָ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 ES_CDECL GetPosition(const TAPISTR_20 UserNo, const TapAPIPositionQryReq *pReqInfo, TapAPIPositionInfo pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûָƽּ¼(ר)
	* @details ˺ѯǱصĲѯ,ûͺ̨Ͽձݡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] pReqInfo ѯͻίĽṹָ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 ES_CDECL GetClose(const TAPISTR_20 UserNo, const TapAPICloseQryReq *pReqInfo, TapAPICloseInfo pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ѯṹָ룬ڶԼա
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_DeepQuote
	*/
	virtual TAPIINT32 ES_CDECL QryDeepQuote(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIContract *pReqInfo) = 0;
	/**
	* @brief ȡָûµĽʱ״̬Ϣ()SeqIDʼÿ෵nOutLenûнҪ´μӲѯһݵSeqID+1ѯ
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡĽϢ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeSystem
	*/
	virtual TAPIINT32 ES_CDECL GetExchangeStateInfo(const TAPISTR_20 UserNo, TAPIUINT32 nDataSeqID, TapAPIExchangeStateInfo* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûµϢ,Ҫڿͻµʱָͨţѡӽ뽻ǰû(ר)
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡͨϢ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_UpperChannelInfo
	*/
	virtual TAPIINT32 ES_CDECL GetUpperChannel(const TAPISTR_20 UserNo, TAPIUINT32 nDataSeqID, TapAPIUpperChannelInfo* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ȡָûеıֵϢSeqIDʼѯÿ෵100ûнҪ´μӲѯһݵSeqIDѯרã
	* @details ˺ִеǱصĲѯ,вɾѾӺ̨ȡıϢݡ
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nDataSeqID ʼѯݱţ1ʾһݣβѯŵݣ
	* @param[in] pOutInfo βѯӦϢָʼַ
	* @param[in] nOutLen βѯӦϢָĳ
	* @param[out] isLast ʾ㱾βѯӦϢǷ
	* @retval retval>=0 βѯķӦϢܸretvalΪʱһ; retval<0 βѯʧܣʾ
	* @operationtype ͬ
	* @ingroup G_T_TradeSystem
	*/
	virtual TAPIINT32 ES_CDECL GetCurrency(const TAPISTR_20 UserNo, TAPIUINT32 nDataSeqID, TapAPICurrencyInfo* pOutInfo[], TAPIUINT32 nOutLen, TAPIYNFLAG& isLast) = 0;
	/**
	* @brief ѯͻշʣרã
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻշʲѯṹָ
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_AccountRentInfo
	*/
	virtual TAPIINT32 ES_CDECL QryAccountRent(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIAccountRentQryReq *pReqInfo) = 0;
	/**
	* @brief ѯͻѲרã
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻշʲѯṹָ
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_AccountRentInfo
	*/
	virtual TAPIINT32 ES_CDECL QryAccountFeeRent(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIAccountFeeRentQryReq *pReqInfo) = 0;
	/**
	* @brief ѯͻ֤רã
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻշʲѯṹָ
	* @retval 0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_AccountRentInfo
	*/
	virtual TAPIINT32 ES_CDECL QryAccountMarginRent(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIAccountMarginRentQryReq *pReqInfo) = 0;
	/**
	* @brief ͻʽѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻʽѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_FundInfo
	*/
	virtual TAPIINT32 ES_CDECL QryAccountCashAdjust(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIAccountCashAdjustQryReq *pReqInfo) = 0;
	/**
	* @brief ѯû˵(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻû˵ѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_Bill
	*/
	virtual TAPIINT32 ES_CDECL QryBill(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIBillQryReq *pReqInfo) = 0;
	/**
	* @brief ʷίвѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻʷίвѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_HisInfo
	*/
	virtual TAPIINT32 ES_CDECL QryHisOrder(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIHisOrderQryReq *pReqInfo) = 0;
	/**
	* @brief ʷί̲ѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻʷί̲ѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_HisInfo
	*/
	virtual TAPIINT32 ES_CDECL QryHisOrderProcess(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIHisOrderProcessQryReq *pReqInfo) = 0;
	/**
	* @brief ʷɽѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻʷɽѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_HisInfo
	*/
	virtual TAPIINT32 ES_CDECL QryHisFill(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIHisFillQryReq *pReqInfo) = 0;
	/**
	* @brief ʷֲֲѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻʷֲֲѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_HisInfo
	*/
	virtual TAPIINT32 ES_CDECL QryHisPosition(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIHisPositionQryReq *pReqInfo) = 0;
	/**
	* @brief ʷѯ(ר)
	* @param[in] UserNo ¼ûUserNo
	* @param[in] nRequestID ID
	* @param[in] pReqInfo ͻʷѯṹָ
	* @retval 0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_HisInfo
	*/
	virtual TAPIINT32 ES_CDECL QryHisDelivery(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIHisDeliveryQryReq *pReqInfo) = 0;
	/**
	* @brief ¼ûֻ豸(ר)
	* @param[in]	UserNo ¼ûUserNo
	* @param[in]	nRequestID ID
	* @param[in]	pReqInfo ¼ûֻ豸ṹ
	* @retval		0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual TAPIINT32 ES_CDECL AddMobileDevice(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIMobileDeviceAddReq *pReqInfo) = 0;
	/**
	* @brief ־ѯ(ר)
	* @param[in]	UserNo ¼ûUserNo
	* @param[in]	nRequestID ID
	* @param[in]	pReqInfo ־ѯṹ
	* @retval		0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual TAPIINT32 ES_CDECL QryManageInfoForEStar(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPIManageInfoQryReq *pReqInfo) = 0;
	/**
	* @brief ϵͳѯ(ר)
	* @param[in]	UserNo ¼ûUserNo
	* @param[in]	nRequestID ID
	* @param[in]	pReqInfo ϵͳѯṹ
	* @retval		0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual TAPIINT32 ES_CDECL QrySystemParameter(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPISystemParameterQryReq *pReqInfo) = 0;
	/**
	* @brief ǰõַϢѯ(ר)
	* @param[in]	UserNo ¼ûUserNo
	* @param[in]	nRequestID ID
	* @param[in]	pReqInfo ǰõַϢѯṹ
	* @retval		0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_Cellphone
	*/
	virtual TAPIINT32 ES_CDECL QryTradeCenterFrontAddress(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPITradeCenterFrontAddressQryReq *pReqInfo) = 0;
    /**
	* @brief Ϣѯ(ר)
	* @param[in]	UserNo ¼ûUserNo
	* @param[in]	nRequestID ID
	* @param[in]	pReqInfo Ϣѯṹ
	* @retval		0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_TradeSystem
	*/
    virtual TAPIINT32 ES_CDECL QryTradeMessage(const TAPISTR_20 UserNo, TAPIUINT32 nRequestID, const TapAPITradeMessageQryReq *pReqInfo) = 0;
};

}

//-----------------------------EsTradeAPI------------------------------------
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus
/**
* @brief	EsTradeAPIĽӿڶ
* @details	APIĽӿ
* @param[in] nResult ӿڵĴ롣
* @retval NULL ʧܣԭͨnResultжϡ
* @retval !NULL	ʵIEsTradeAPIӿڵĶָ롣
* @ingroup G_T_API
*/
ES_DLLEXPORT EsTradeAPI::IEsTradeAPI *ES_CDECL CreateEsTradeAPI(EsTradeAPI::TAPIINT32& nResult);
/**
* @brief	ͨCreateEsTradeAPIIEsTradeAPI
* @param[in] pApiObj IEsTradeAPIָ롣
* @ingroup G_T_API
*/
ES_DLLEXPORT void ES_CDECL FreeEsTradeAPI(EsTradeAPI::IEsTradeAPI *pApiObj);
/**
* @brief	ȡEsTradeAPIİ汾Ϣ
* @param[out] pVersion ⲿַ飬API汾š
* @param[in] nVersionLen ַ鳤ȣ50ַ
* @ingroup G_T_API
*/
ES_DLLEXPORT void ES_CDECL GetEsTradeAPIVersion(char* pVersion, int nVersionLen);
#ifdef __cplusplus
}
#endif // __cplusplus

#endif // ES_TRADE_API_H