//=============================================================================
/* ʢͳһAPIӿ
 * ļEsTradeAPI ʹõ
 * 汾Ϣ:2018-05-21  ļ
 */
//=============================================================================
#ifndef ES_TRADE_API_DATA_TYPE_H
#define ES_TRADE_API_DATA_TYPE_H
namespace EsTradeAPI
{
#pragma pack(push, 1)

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_CHARS	ַͶ
	 *	@{
	 */
	 //=============================================================================
	 //! ַ壬ڶ
	typedef char					TAPICHAR;
	//! Ϊ10ַ
	typedef char					TAPISTR_10[11];
	//! Ϊ20ַ
	typedef char					TAPISTR_20[21];
	//! Ϊ30ַ
	typedef char					TAPISTR_30[31];
	//! Ϊ40ַ
	typedef char					TAPISTR_40[41];
	//! Ϊ50ַ
	typedef char					TAPISTR_50[51];
	//! Ϊ70ַ
	typedef char					TAPISTR_70[71];
	//! Ϊ100ַ
	typedef char					TAPISTR_100[101];
	//! Ϊ200ַ
	typedef char					TAPISTR_200[201];
	//! Ϊ300ַ
	typedef char					TAPISTR_300[301];
	//! Ϊ500ַ
	typedef char					TAPISTR_500[501];
	//! Ϊ2000ַ
	typedef char					TAPISTR_2000[2001];
	//! Ϊ512ַ֤Authorization Code
	typedef char					TAPIAUTHCODE[513];
	//! ֤
	typedef char                	TAPISecondSerialIDType[5];

	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_NUMBER	ֵͶ
	 *	@{
	 */
	 //=============================================================================
	 //! int 32
	typedef int						TAPIINT32;
	//! unsigned 32
	typedef unsigned int			TAPIUINT32;
	//! int 64
	typedef long long				TAPIINT64;
	//! unsigned 64
	typedef unsigned long long		TAPIUINT64;
	//! unsigned 16
	typedef unsigned short			TAPIUINT16;
	//! unsigned 8
	typedef unsigned char			TAPIUINT8;
	//! real 64
	typedef double					TAPIREAL64;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_YNFLAG	Ƿʾ
	 *	@{
	 */
	 //=============================================================================
	 //! Ƿʾ
	typedef TAPICHAR				TAPIYNFLAG;
	//! 
	const TAPIYNFLAG				APIYNFLAG_YES = 'Y';
	//! 
	const TAPIYNFLAG				APIYNFLAG_NO = 'N';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_DATETIME	ʱͶ
	 *	@{
	 */
	 //=============================================================================
	 //! ʱ(ʽ yyyy-MM-dd hh:nn:ss.xxx)
	typedef char					TAPIDTSTAMP[24];
	//! ںʱ(ʽ yyyy-MM-dd hh:nn:ss)
	typedef char					TAPIDATETIME[20];
	//! (ʽ yyyy-MM-dd)
	typedef char					TAPIDATE[11];
	//! ʱ(ʽ hh:nn:ss)
	typedef char					TAPITIME[9];
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_LOG_LEVEL	־
	 *	@{
	 */
	 //=============================================================================
	 //! ־
	typedef TAPICHAR				TAPILOGLEVEL;
	//! Error
	const TAPILOGLEVEL				APILOGLEVEL_ERROR = '1';
	//! Normal
	const TAPILOGLEVEL				APILOGLEVEL_NORMAL = '2';
	//! Debug
	const TAPILOGLEVEL				APILOGLEVEL_DEBUG = '3';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_COMMODITY_TYPE	Ʒ
	 *	@{
	 */
	 //=============================================================================
	 //! Ʒ
	typedef TAPICHAR				TAPICommodityType;
	//! 
	const TAPICommodityType			TAPI_COMMODITY_TYPE_NONE = 'N';
	//! ֻ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_SPOT = 'P';
	//! ڻ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_FUTURES = 'F';
	//! Ȩ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_OPTION = 'O';
	//! 
	const TAPICommodityType			TAPI_COMMODITY_TYPE_SPREAD_MONTH = 'S';
	//! Ʒ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_SPREAD_COMMODITY = 'M';
	//! Ǵֱ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_BUL = 'U';
	//! ֱ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_BER = 'E';
	//! ʽ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_STD = 'D';
	//! ʽ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_STG = 'G';
	//! 
	const TAPICommodityType			TAPI_COMMODITY_TYPE_PRT = 'R';
	//! ˮƽȨ
	const TAPICommodityType		    TAPI_COMMODITY_TYPE_BLT = 'L';
	//! ˮƽȨ
	const TAPICommodityType   		TAPI_COMMODITY_TYPE_BRT = 'Q';
	//! 㡪ֱӻ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_DIRECTFOREX = 'X';
	//! 㡪ӻ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_INDIRECTFOREX = 'I';
	//! 㡪
	const TAPICommodityType			TAPI_COMMODITY_TYPE_CROSSFOREX = 'C';
	//! ָ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_INDEX = 'Z';
	//! Ʊ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_STOCK = 'T';
	//! ֻ
	const TAPICommodityType			TAPI_COMMODITY_TYPE_SPOT_TRADINGDEFER = 'Y';
	//! 
	const TAPICommodityType	    	TAPI_COMMODITY_TYPE_FUTURE_LOCK = 'J';
	//! нEFP
	const TAPICommodityType		    TAPI_COMMODITY_TYPE_EFP = 'A';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_CALL_OR_PUT	ǿʾ
	 *	@{
	 */
	 //=============================================================================
	 //! ǿʾ
	typedef TAPICHAR				TAPICallOrPutFlagType;
	//! Ȩ
	const TAPICallOrPutFlagType		TAPI_CALLPUT_FLAG_CALL = 'C';
	//! Ȩ
	const TAPICallOrPutFlagType		TAPI_CALLPUT_FLAG_PUT = 'P';
	//! 
	const TAPICallOrPutFlagType		TAPI_CALLPUT_FLAG_NONE = 'N';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIACCOUNTTYPE	˺
	 *	@{
	 */
	 //=============================================================================
	 //! ˺
	typedef TAPICHAR				TAPIAccountType;
	//! ˿ͻ
	const TAPIAccountType			TAPI_ACCOUNT_TYPE_PERSON = 'P';
	//! ͻ
	const TAPIAccountType			TAPI_ACCOUNT_TYPE_ORGANIZATION = 'O';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIRIGHTIDTYPE	Ȩޱ
	*	@{
	*/
	//=============================================================================
	//! Ȩޱ
	typedef TAPIINT32				TAPIRightIDType;
	//! ϵͳɾ
	const TAPIRightIDType			TAPI_RIGHT_ORDER_DEL = 30001;
	//! 
	const TAPIRightIDType			TAPI_RIGHT_ORDER_CHECK = 30002;
	//! ֻɲѯ
	const TAPIRightIDType			TAPI_RIGHT_ONLY_QRY = 31000;
	//! ֻɿ
	const TAPIRightIDType			TAPI_RIGHT_ONLY_OPEN = 31001;
	//! ڲҵ
	const TAPIRightIDType			TAPI_RIGHT_SHFE_QUOTE = 31002;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIUSERTYPETYPE	¼û
	 *	@{
	 */
	 //=============================================================================
	 //! ¼û
	typedef TAPIINT32				TAPIUserTypeType;
	//! Ͷû
	const TAPIUserTypeType			TAPI_USERTYPE_CLIENT = 10000;
	//! 
	const TAPIUserTypeType			TAPI_USERTYPE_BROKER = 20000;
	//! Ա
	const TAPIUserTypeType			TAPI_USERTYPE_TRADER = 30000;
	//! 
	const TAPIUserTypeType			TAPI_USERTYPE_RISK = 40000;
	//! Ա
	const TAPIUserTypeType			TAPI_USERTYPE_MANAGER = 50000;
	//! 
	const TAPIUserTypeType			TAPI_USERTYPE_QUOTE = 60000;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIACCOUNTSTATE	˺״̬
	 *	@{
	 */
	 //=============================================================================
	 //! ˺״̬
	typedef TAPICHAR				TAPIAccountState;
	//! 
	const TAPIAccountState			TAPI_ACCOUNT_STATE_NORMAL = 'N';
	//! 
	const TAPIAccountState			TAPI_ACCOUNT_STATE_CANCEL = 'C';
	//! 
	const TAPIAccountState			TAPI_ACCOUNT_STATE_SLEEP = 'S';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIACCOUNTFAMILYTYPE	˻
	 *	@{
	 */
	 //=============================================================================
	 //! ˻
	typedef TAPICHAR				TAPIAccountFamilyType;
	//! ˺
	const	TAPIAccountFamilyType	TAPI_ACCOUNT_FAMILYTYPE_NOMAL = 'N';
	//! ˻
	const	TAPIAccountFamilyType	TAPI_ACCOUNT_FAMILYTYPE_CHILD = 'C';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIORDERTYPETYPE	ί
	 *	@{
	 */
	 //=============================================================================
	 //! ί
	typedef TAPICHAR				TAPIOrderTypeType;
	//! м
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_MARKET = '1';
	//! ޼
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_LIMIT = '2';
	//! мֹ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_STOP_MARKET = '3';
	//! ޼ֹ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_STOP_LIMIT = '4';
	//! ȨȨ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPT_EXEC = '5';
	//! ȨȨ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPT_ABANDON = '6';
	//! ѯ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_REQQUOT = '7';
	//! Ӧ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_RSPQUOT = '8';
	//! 
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_SWAP = '9';
	//! 
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_COMB = 'A';
	//! 
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_UNCOMB = 'B';
	//! мֹӯ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_PROFIT_MARKET = 'C';
	//! ޼ֹӯ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_PROFIT_LIMIT = 'D';
	//! ױ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_HEDGE = 'E';
	//! ȨԶԳ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPTION_AUTO_CLOSE = 'F';
	//! ԼڻԶԳ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_FUTURE_AUTO_CLOSE = 'G';
	//! 
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_MARKET_POSITION_KEEP = 'H';
	//! ȡԶȨ
	const TAPIOrderTypeType			TAPI_ORDER_TYPE_OPTION_AUTOEXEC_ABAND = 'I';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIORDERSOURCETYPE	ίԴ
	 *	@{
	 */
	 //=============================================================================
	 //! ίԴ
	typedef TAPICHAR				TAPIOrderSourceType;
	//! ӵ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_SELF_ETRADER = '1';
	//! ӵ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_PROXY_ETRADER = '2';
	//! ⲿӵ(ⲿϵͳµϵͳ¼)
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_JTRADER = '3';
	//! ˹¼뵥(ⲿʽµϵͳ¼)
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_MANUAL = '4';
	//! carry
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_CARRY = '5';
	//! ʽ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_PROGRAM = '6';
	//! Ȩ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_DELIVERY = '7';
	//! Ȩ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_ABANDON = '8';
	//! ͨ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_CHANNEL = '9';
	//! ʢAPI
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_ESUNNY_API = 'A';
	//! ʢV8ͻ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_ESV8CLIENT = 'B';
	//! ʢǿͻ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_EPOLESTAR = 'C';
	//! ʢǿͻ
	const TAPIOrderSourceType		TAPI_ORDER_SOURCE_ESTAR = 'D';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPITIMEINFORCETYPE	ίЧ
	 *	@{
	 */
	 //=============================================================================
	 //! ίЧ
	typedef TAPICHAR				TAPITimeInForceType;
	//! Ч(ָֻֻ֧)
	const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_GFD = '0';
	//! ȡǰЧ
	const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_GTC = '1';
	//! ָǰЧ
	const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_GTD = '2';
	//! FAKIOC
	const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_FAK = '3';
	//! FOK
	const TAPITimeInForceType		TAPI_ORDER_TIMEINFORCE_FOK = '4';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPISIDETYPE	
	 *	@{
	 */
	 //=============================================================================
	 //! 
	typedef TAPICHAR				TAPISideType;
	//! 
	const TAPISideType				TAPI_SIDE_NONE = 'N';
	//! 
	const TAPISideType				TAPI_SIDE_BUY = 'B';
	//! 
	const TAPISideType				TAPI_SIDE_SELL = 'S';
	//! ˫
	const TAPISideType				TAPI_SIDE_ALL = 'A';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIPOSITIONEFFECTTYPE	ƽ
	 *	@{
	 */
	 //=============================================================================
	 //! ƽ
	typedef TAPICHAR				TAPIPositionEffectType;
	//! ֿƽ
	const TAPIPositionEffectType	TAPI_PositionEffect_NONE = 'N';
	//! 
	const TAPIPositionEffectType	TAPI_PositionEffect_OPEN = 'O';
	//! ƽ
	const TAPIPositionEffectType	TAPI_PositionEffect_COVER = 'C';
	//! ƽ
	const TAPIPositionEffectType	TAPI_PositionEffect_COVER_TODAY = 'T';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIHEDGEFLAGTYPE	Ͷֵ
	 *	@{
	 */
	 //=============================================================================
	 //! Ͷֵ
	typedef TAPICHAR				TAPIHedgeFlagType;
	//! 
	const TAPIHedgeFlagType			TAPI_HEDGEFLAG_NONE = 'N';
	//! Ͷ
	const TAPIHedgeFlagType			TAPI_HEDGEFLAG_T = 'T';
	//! ֵ
	const TAPIHedgeFlagType			TAPI_HEDGEFLAG_B = 'B';
	//! 
	const TAPIHedgeFlagType			TAPI_HEDGEFLAG_L = 'L';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIORDERSTATETYPE	ί״̬
	 *	@{
	 */
	 //=============================================================================
	 //! ί״̬
	typedef TAPICHAR				TAPIOrderStateType;
	//! նύ
	const TAPIOrderStateType		TAPI_ORDER_STATE_SUBMIT = '0';
	//! 
	const TAPIOrderStateType		TAPI_ORDER_STATE_ACCEPT = '1';
	//! Դ
	const TAPIOrderStateType		TAPI_ORDER_STATE_TRIGGERING = '2';
	//! 
	const TAPIOrderStateType		TAPI_ORDER_STATE_EXCTRIGGERING = '3';
	//! Ŷ
	const TAPIOrderStateType		TAPI_ORDER_STATE_QUEUED = '4';
	//! ֳɽ
	const TAPIOrderStateType		TAPI_ORDER_STATE_PARTFINISHED = '5';
	//! ȫɽ
	const TAPIOrderStateType		TAPI_ORDER_STATE_FINISHED = '6';
	//! (Ŷʱ״̬)
	const TAPIOrderStateType		TAPI_ORDER_STATE_CANCELING = '7';
	//! ޸(Ŷʱ״̬)
	const TAPIOrderStateType		TAPI_ORDER_STATE_MODIFYING = '8';
	//! ȫ
	const TAPIOrderStateType		TAPI_ORDER_STATE_CANCELED = '9';
	//! ѳ൥
	const TAPIOrderStateType		TAPI_ORDER_STATE_LEFTCANCELED = 'A';
	//! ָʧ
	const TAPIOrderStateType		TAPI_ORDER_STATE_FAIL = 'B';
	//! ɾ
	const TAPIOrderStateType		TAPI_ORDER_STATE_DELETED = 'C';
	//! ѹ
	const TAPIOrderStateType		TAPI_ORDER_STATE_SUPPENDED = 'D';
	//! ɾ
	const TAPIOrderStateType		TAPI_ORDER_STATE_DELETEDFOREXPIRE = 'E';
	//! Чѯ۳ɹ
	const TAPIOrderStateType		TAPI_ORDER_STATE_EFFECT = 'F';
	//! 롪ȨȨɹ
	const TAPIOrderStateType		TAPI_ORDER_STATE_APPLY = 'G';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPICALCULATEMODETYPE	㷽ʽ
	 *	@{
	 */
	 //=============================================================================
	 //! 㷽ʽ
	typedef TAPICHAR				TAPICalculateModeType;
	//! 
	const TAPICalculateModeType		TAPI_CALCULATE_MODE_PERCENTAGE = '1';
	//! 
	const TAPICalculateModeType		TAPI_CALCULATE_MODE_QUOTA = '2';
	//! Էʽ
	const TAPICalculateModeType		TAPI_CALCULATE_MODE_ABSOLUTE = '7';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIMATCHSOURCETYPE	ɽԴ
	 *	@{
	 */
	 //=============================================================================
	 //! ɽԴ
	typedef TAPICHAR				TAPIMatchSourceType;
	//! ȫ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_ALL = '0';
	//! ӵ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_SELF_ETRADER = '1';
	//! ӵ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_PROXY_ETRADER = '2';
	//! ⲿӵ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_JTRADER = '3';
	//! ˹¼뵥
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_MANUAL = '4';
	//! carry
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_CARRY = '5';
	//! ʽ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_PROGRAM = '6';
	//! Ȩ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_DELIVERY = '7';
	//! Ȩ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_ABANDON = '8';
	//! ͨ
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_CHANNEL = '9';
	//! ʢAPI
	const TAPIMatchSourceType		TAPI_MATCH_SOURCE_ESUNNY_API = 'A';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIOPENCLOSEMODETYPE	ƽʽ
	 *	@{
	 */
	 //=============================================================================
	 //! ƽʽ
	typedef TAPICHAR				TAPIOpenCloseModeType;
	//! ֿƽ
	const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_NONE = 'N';
	//! ƽδ˽
	const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_UNFINISHED = 'U';
	//! ֺֿƽ
	const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_OPENCOVER = 'C';
	//! ֿ֡ƽֺƽ
	const TAPIOpenCloseModeType		TAPI_CLOSE_MODE_CLOSETODAY = 'T';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIFUTUREALGTYPE	ڻ㷨
	 *	@{
	 */
	 //=============================================================================
	 //! ڻ㷨
	typedef TAPICHAR				TAPIFutureAlgType;
	//! 
	const TAPIFutureAlgType			TAPI_FUTURES_ALG_ZHUBI = '1';
	//! 
	const TAPIFutureAlgType			TAPI_FUTURES_ALG_DINGSHI = '2';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIOPTIONALGTYPE	Ȩ㷨
	 *	@{
	 */
	 //=============================================================================
	 //! Ȩ㷨
	typedef TAPICHAR				TAPIOptionAlgType;
	//! ڻʽ
	const TAPIOptionAlgType         TAPI_OPTION_ALG_FUTURES = '1';
	//! Ȩʽ
	const TAPIOptionAlgType         TAPI_OPTION_ALG_OPTION = '2';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIBANKACCOUNTLWFLAGTYPE	ұʶ
	 *	@{
	 */
	 //=============================================================================
	 //! ұʶ
	typedef TAPICHAR				TAPIBankAccountLWFlagType;
	//! ˻
	const TAPIBankAccountLWFlagType	TAPI_LWFlag_L = 'L';
	//! ͻ˻
	const TAPIBankAccountLWFlagType	TAPI_LWFlag_W = 'W';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIMARGINCALCULATEMODETYPE	ڻ֤ʽ
	 *	@{
	 */
	 //=============================================================================
	 //! ڻ֤ʽ
	typedef TAPICHAR				TAPIMarginCalculateModeType;
	//! ֱ
	const TAPIMarginCalculateModeType TAPI_DEPOSITCALCULATE_MODE_FEN = '1';
	//! 
	const TAPIMarginCalculateModeType TAPI_DEPOSITCALCULATE_MODE_SUO = '2';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIOPTIONMARGINCALCULATEMODETYPE	Ȩ֤ʽ
	 *	@{
	 */
	 //=============================================================================
	 //! Ȩ֤ʽ,ݴжϸƷȨúü㹫ʽ㱣֤
	typedef TAPICHAR				TAPIOptionMarginCalculateModeType;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPICMBDIRECTTYPE	Ϸ
	 *	@{
	 */
	 //=============================================================================
	 //! Ϸ,ƷϺԼ͵ڼͬ
	typedef TAPICHAR				TAPICmbDirectType;
	//! ͵һһ
	const TAPICmbDirectType         TAPI_CMB_DIRECT_FIRST = '1';
	//! ͵ڶһ
	const TAPICmbDirectType         TAPI_CMB_DIRECT_SECOND = '2';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIDELIVERYMODETYPE	Ȩʽ
	 *	@{
	 */
	 //=============================================================================
	 //! Ȩʽ,ڻȨ˽ķʽ
	typedef TAPICHAR				TAPIDeliveryModeType;
	//! ʵｻ
	const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_GOODS = 'G';
	//! ֽ𽻸
	const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_CASH = 'C';
	//! ȨȨ
	const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_EXECUTE = 'E';
	//! Ȩ
	const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_ABANDON = 'A';
	//! ۽Ȩ
	const TAPIDeliveryModeType		TAPI_DELIVERY_MODE_HKF = 'H';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPICONTRACTTYPETYPE	Լ
	 *	@{
	 */
	 //=============================================================================
	 //! Լ
	typedef TAPICHAR				TAPIContractTypeType;
	//! Լ
	const TAPIContractTypeType		TAPI_CONTRACT_TYPE_TRADEQUOTE = '1';
	//! Լ
	const TAPIContractTypeType		TAPI_CONTRACT_TYPE_QUOTE = '2';
	/** @}*/

	//=============================================================================
	//T+1ɽ
	typedef TAPICHAR				TAPIIsAddOneType;
	//T+1ɽ
	const TAPIIsAddOneType			TAPI_ISADD_ONE_YES = 'Y';
	//T+1ɽ
	const TAPIIsAddOneType			TAPI_ISADD_ONE_NO = 'N';

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPITACTICSTYPETYPE	Ե
	 *	@{
	 */
	 //=============================================================================
	 //! Ե
	typedef TAPICHAR				TAPITacticsTypeType;
	//! 
	const TAPITacticsTypeType		TAPI_TACTICS_TYPE_NONE = 'N';
	//! Ԥ()
	const TAPITacticsTypeType		TAPI_TACTICS_TYPE_READY = 'M';
	//! Զ
	const TAPITacticsTypeType		TAPI_TACTICS_TYPE_ATUO = 'A';
	//! 
	const TAPITacticsTypeType		TAPI_TACTICS_TYPE_CONDITION = 'C';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIORDERACT	
	 *	@{
	 */
	 //=============================================================================
	 //! 
	typedef TAPICHAR				TAPIORDERACT;
	//! 
	const TAPIORDERACT				APIORDER_INSERT = '1';
	//! ĵ
	const TAPIORDERACT				APIORDER_MODIFY = '2';
	//! 
	const TAPIORDERACT				APIORDER_DELETE = '3';
	//! 
	const TAPIORDERACT				APIORDER_SUSPEND = '4';
	//! 
	const TAPIORDERACT				APIORDER_ACTIVATE = '5';
	//! ɾ
	const TAPIORDERACT				APIORDER_SYSTEM_DELETE = '6';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPITRIGGERCONDITIONTYPE	
	 *	@{
	 */
	 //=============================================================================
	 //! 
	typedef TAPICHAR				TAPITriggerConditionType;
	//! 
	const TAPITriggerConditionType	TAPI_TRIGGER_CONDITION_NONE = 'N';
	//! ڵ
	const TAPITriggerConditionType	TAPI_TRIGGER_CONDITION_GREAT = 'G';
	//! Сڵ
	const TAPITriggerConditionType	TAPI_TRIGGER_CONDITION_LITTLE = 'L';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPITRIGGERPRICETYPETYPE	۸
	 *	@{
	 */
	 //=============================================================================
	 //! ۸
	typedef TAPICHAR				TAPITriggerPriceTypeType;
	//! 
	const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_NONE = 'N';
	//! 
	const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_BUY = 'B';
	//! 
	const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_SELL = 'S';
	//! ¼
	const TAPITriggerPriceTypeType	TAPI_TRIGGER_PRICE_LAST = 'L';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIMARKETLEVELTYPE	м۴
	 *	@{
	 */
	 //=============================================================================
	 //! м۴
	typedef TAPIUINT8				TAPIMarketLevelType;
	//! 
	const TAPIMarketLevelType		TAPI_MARKET_LEVEL_0 = 0;
	//! 1ż
	const TAPIMarketLevelType		TAPI_MARKET_LEVEL_1 = 1;
	//! 5
	const TAPIMarketLevelType		TAPI_MARKET_LEVEL_5 = 5;
	//! 10
	const TAPIMarketLevelType		TAPI_MARKET_LEVEL_10 = 10;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPITRADINGSTATETYPE	״̬
	 *	@{
	 */
	 //=============================================================================
	 //! ״̬
	typedef TAPICHAR				TAPITradingStateType;
	//! Ͼ
	const TAPITradingStateType		TAPI_TRADE_STATE_BID = '1';
	//! Ͼ۴
	const TAPITradingStateType		TAPI_TRADE_STATE_MATCH = '2';
	//! 
	const TAPITradingStateType		TAPI_TRADE_STATE_CONTINUOUS = '3';
	//! ͣ
	const TAPITradingStateType		TAPI_TRADE_STATE_PAUSED = '4';
	//! 
	const TAPITradingStateType		TAPI_TRADE_STATE_CLOSE = '5';
	//! дʱ
	const TAPITradingStateType		TAPI_TRADE_STATE_DEALLAST = '6';
	//! δ
	const TAPITradingStateType		TAPI_TRADE_STATE_GWDISCONNECT = '0';
	//! δ֪״̬
	const TAPITradingStateType		TAPI_TRADE_STATE_UNKNOWN = 'N';
	//! ʼ
	const TAPITradingStateType		TAPI_TRADE_STATE_INITIALIZE = 'I';
	//! ׼
	const TAPITradingStateType		TAPI_TRADE_STATE_READY = 'R';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPINOTICEIGNOREFLAGTYPE	Ժ̨֪ͨ
	 *	@{
	 */
	 //=============================================================================
	 //! Ժ̨֪ͨ
	typedef TAPIUINT32				TAPINoticeIgnoreFlagType;
	//! Ϣ
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_NONE = 0x00000000;
	//! 
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_ALL = 0xFFFFFFFF;
	//! ʽ:OnRtnFund
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_FUND = 0x00000001;
	//! ί:OnRtnOrder
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_ORDER = 0x00000002;
	//! Գɽ:OnRtnFill
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_FILL = 0x00000004;
	//! Գֲ:OnRtnPosition
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_POSITION = 0x00000008;
	//! ƽ:OnRtnClose
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_CLOSE = 0x00000010;
	//! Գֲӯ:OnRtnPositionProfit
	const TAPINoticeIgnoreFlagType	TAPI_NOTICE_IGNORE_POSITIONPROFIT = 0x00000020;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPIORDERQRYTYPETYPE	ίвѯ
	 *	@{
	 */
	 //=============================================================================
	 //! ίвѯ
	typedef TAPICHAR				TAPIOrderQryTypeType;
	//! ί
	const TAPIOrderQryTypeType		TAPI_ORDER_QRY_TYPE_ALL = 'A';
	//! ֻδί
	const TAPIOrderQryTypeType		TAPI_ORDER_QRY_TYPE_UNENDED = 'U';
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_T_TAPISystemTypeTypeE	̨ϵͳ
	 *	@{
	 */
	 //=============================================================================
	 //! ̨ϵͳ
	typedef TAPIUINT32				TAPISystemTypeType;
	//! ϵͳ
	const TAPISystemTypeType		TAPI_SYSTEM_TYPE_ESUNNY = 1;
	//! ̱ϵͳ
	const TAPISystemTypeType		TAPI_SYSTEM_TYPE_IESUNNY = 2;
	//! ֻ̨ϵͳ
	const TAPISystemTypeType		TAPI_SYSTEM_TYPE_CELLPHONE = 3;
	/** @}*/

	//=============================================================================
	/**
	 *	\addtogroup G_DATATYPE_LOGINTPYE	¼
	 *	@{
	 */
	 //=============================================================================
	 //! ¼
	typedef TAPIUINT32				TAPILoginTypeType;
	//! ͨTCP
	const TAPILoginTypeType			TAPI_LOGINTYPE_NORMAL = 1;
	//! TCP(ݲ֧)
	const TAPILoginTypeType			TAPI_LOGINTYPE_GMSSL = 2;
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIMSGLEVELTYPE	Ϣ
	*	@{
	*/
	//=============================================================================
	//! Ϣ
	typedef TAPICHAR				TAPIMsgLevelType;
	//! ͨ
	const TAPIMsgLevelType			TAPI_MSG_LEVEL_NORMAL = '1';
	//! Ҫ
	const TAPIMsgLevelType			TAPI_MSG_LEVEL_IMPORTANT = '2';
	//! 
	const TAPIMsgLevelType			TAPI_MSG_LEVEL_IMERGENCY = '3';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIMSGTYPETYPE	Ϣ
	*	@{
	*/
	//=============================================================================
	//! Ϣ
	typedef TAPICHAR				TAPIMsgTypeType;
	//! 
	const TAPIMsgTypeType			TAPI_Msg_TYPE_MANAGER = '1';
	//! 
	const TAPIMsgTypeType			TAPI_Msg_TYPE_RISKCONTROL = '2';
	/** @}*/
    
    //=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIMSGQRYTYPETYPE	ϢͲѯ
	*	@{
	*/
	//=============================================================================
    //! Ϣѯ(רãĄ̊́Ĭȫ)
	typedef TAPICHAR				TAPIMsgQryTypeType;
    //! ȫ
    const TAPIMsgQryTypeType        TAPI_Msg_QRYTYPE_ALL = 'A';
    //! Ч
    const TAPIMsgQryTypeType        TAPI_Msg_QRYTYPE_VALID = 'Y';
    /** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPICASHADJUSTTYPETYPE	ʽ
	*	@{
	*/
	//=============================================================================
	//! ʽ
	typedef TAPICHAR						TAPICashAdjustTypeType;
	//! ѵ
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_FEEADJUST = '0';
	//! ӯ
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_YKADJUST = '1';
	//! Ѻʽ
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_PLEDGE = '2';
	//! Ϣ
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_INTERESTREVENUE = '3';
	//! ۷
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_COLLECTIONCOST = '4';
	//! 
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_OTHER = '5';
	//! ˾䲦
	const TAPICashAdjustTypeType			TAPI_CASHINOUT_MODE_COMPANY = '6';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIBILLTYPETYPE	˵
	*	@{
	*/
	//=============================================================================
	//! ˵
	typedef TAPICHAR				TAPIBillTypeType;
	//! ˵
	const TAPIBillTypeType			TAPI_BILL_DATE = 'D';
	//! ˵
	const TAPIBillTypeType			TAPI_BILL_MONTH = 'M';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIBILLFILETYPETYPE	ʵļ
	*	@{
	*/
	//=============================================================================
	//! ʵļ
	typedef TAPICHAR				TAPIBillFileTypeType;
	//! txtʽļ
	const TAPIBillFileTypeType		TAPI_BILL_FILE_TXT = 'T';
	//! pdfʽļ
	const TAPIBillFileTypeType		TAPI_BILL_FILE_PDF = 'F';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIAUTHTYPETYPE	Ȩ¼ļ
	*	@{
	*/
	//=============================================================================
	//! Ȩ¼ļ
	typedef TAPICHAR				TAPIAuthTypeType;
	//! ֱģʽ
	const TAPIAuthTypeType			TAPI_AUTHTYPE_DIRECT = '1';
	//! мģʽ
	const TAPIAuthTypeType			TAPI_AUTHTYPE_RELAY = '2';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPISENDTYPETYPE	֤ͷʽ
	*	@{
	*/
	//=============================================================================
	//! ֤ͷʽ
	typedef TAPICHAR				TAPISendTypeType;
	//! 
	const TAPISendTypeType          TAPI_SENDTYPE_SMS = 'S';
	//! ʼ
	const TAPISendTypeType          TAPI_SENDTYPE_MAIL = 'M';
	/** @}*/

	//=============================================================================
	/**
	*	\addtogroup G_DATATYPE_T_TAPIDEVICETYPETYPE	ֻ豸
	*	@{
	*/
	//=============================================================================
	//! ֻ豸
	typedef TAPICHAR				TAPIDeviceTypeType;
	//! Android
	const TAPIDeviceTypeType        TAPI_DEVICETYPE_ANDROID = '0';
	//! IOS
	const TAPIDeviceTypeType        TAPI_DEVICETYPE_IOS = '1';

#pragma pack(pop)
}
#endif